/*!
 * @huiweitech/ant-design-vue v4.0.0
 * (c) 2018-2023 huiweitech
 * Github https://github.com/xaboy/form-create
 * Released under the MIT License.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.formCreate = {}, global.Vue));
})(this, (function (exports, vue) { 'use strict';

    function toArray(value) {
      return Array.isArray(value) ? value : [null, undefined, ''].indexOf(value) > -1 ? [] : [value];
    }

    function getSlot(slots, exclude) {
      return Object.keys(slots).reduce((lst, name) => {
        if (!exclude || exclude.indexOf(name) === -1) {
          lst.push(slots[name]);
        }
        return lst;
      }, []);
    }

    var script$8 = {
      name: 'PlusOutlined'
    };

    const _hoisted_1$8 = {
      class: "anticon"
    };
    const _hoisted_2$8 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("defs"), /*#__PURE__*/vue.createElementVNode("path", {
      d: "M482 152h60q8 0 8 8v704q0 8-8 8h-60q-8 0-8-8V160q0-8 8-8z",
      fill: "currentColor"
    }), /*#__PURE__*/vue.createElementVNode("path", {
      d: "M176 474h672q8 0 8 8v60q0 8-8 8H176q-8 0-8-8v-60q0-8 8-8z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$8 = [_hoisted_2$8];
    function render$8(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$8, _hoisted_3$8);
    }

    script$8.render = render$8;

    const parseFile = function (file, uid) {
        return {
          url: file,
          name: getFileName(file),
          status: 'done',
          uid: -1 * (uid + 1)
        };
      },
      getFileName = function (file) {
        return ('' + file).split('/').pop();
      },
      parseUpload = function (file) {
        return {
          url: file.url,
          file,
          uid: file.uid
        };
      };
    const NAME$5 = 'fcUpload';
    var Upload = vue.defineComponent({
      name: NAME$5,
      inheritAttrs: false,
      formCreateParser: {
        toFormValue(value) {
          return toArray(value);
        },
        toValue(formValue, ctx) {
          return ctx.prop.props.limit === 1 ? formValue[0] || '' : formValue;
        }
      },
      props: {
        limit: {
          type: Number,
          default: 0
        },
        modelValue: {
          type: Array,
          default: () => []
        },
        onSuccess: {
          type: Function,
          required: true
        },
        onPreview: Function,
        modalTitle: String,
        previewMask: undefined
      },
      emits: ['update:modelValue', 'change'],
      data() {
        return {
          previewImage: '',
          previewVisible: false,
          uploadList: this.modelValue.map(parseFile).map(parseUpload)
        };
      },
      watch: {
        modelValue(n) {
          this.uploadList = n.map(parseFile).map(parseUpload);
        }
      },
      methods: {
        handlePreview(file) {
          if (this.onPreview) {
            this.onPreview(...arguments);
          } else {
            this.previewImage = file.url;
            this.previewVisible = true;
          }
        },
        handleChange({
          file,
          fileList
        }) {
          this.$emit('change', ...arguments);
          this.uploadList = fileList;
          if (file.status === 'done') {
            this.onSuccess(file, fileList);
            this.input();
          } else if (file.status === 'removed') {
            fileList.forEach((v, i) => {
              if (v.file === file) {
                fileList.splice(i, 1);
              }
            });
            this.input();
          }
        },
        input() {
          this.$emit('update:modelValue', this.uploadList.map(v => v.url));
        }
      },
      render() {
        var _this$$slots$default, _this$$slots;
        const isShow = !this.limit || this.limit > this.uploadList.length;
        return vue.createVNode(vue.Fragment, null, [vue.createVNode(vue.resolveComponent("AUpload"), vue.mergeProps({
          "maxCount": this.limit,
          "list-type": 'picture-card'
        }, this.$attrs, {
          "onPreview": this.handlePreview,
          "onChange": this.handleChange,
          "fileList": this.uploadList,
          "ref": "upload"
        }), {
          default: () => [isShow ? ((_this$$slots$default = (_this$$slots = this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)) || vue.createVNode(script$8, {
            "style": "font-size: 16px; width: 16px;"
          }, null) : null],
          ...getSlot(this.$slots, ['default'])
        }), vue.createVNode(vue.resolveComponent("aModal"), {
          "mask": this.previewMask,
          "title": this.modalTitle,
          "visible": this.previewVisible,
          "onCancel": () => this.previewVisible = false,
          "footer": null
        }, {
          default: () => [vue.createVNode("img", {
            "style": "width: 100%",
            "src": this.previewImage
          }, null)]
        })]);
      }
    });

    // https://github.com/developit/mitt

    function Mitt(all) {
      all = all || new Map();
      const mitt = {
        $on(type, handler) {
          const handlers = all.get(type);
          const added = handlers && handlers.push(handler);
          if (!added) {
            all.set(type, [handler]);
          }
        },
        $once(type, handler) {
          handler._once = true;
          mitt.$on(type, handler);
        },
        $off(type, handler) {
          const handlers = all.get(type);
          if (handlers) {
            handlers.splice(handlers.indexOf(handler) >>> 0, 1);
          }
        },
        $emit(type, ...args) {
          (all.get(type) || []).slice().map(handler => {
            if (handler._once) {
              mitt.$off(type, handler);
              delete handler._once;
            }
            handler(...args);
          });
          (all.get('*') || []).slice().map(handler => {
            handler(type, args);
          });
        }
      };
      return mitt;
    }

    var script$7 = {
      name: 'CloseCircleOutlined'
    };

    const _hoisted_1$7 = {
      class: "anticon"
    };
    const _hoisted_2$7 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M685.4 354.8c0-4.4-3.6-8-8-8l-66 .3L512 465.6l-99.3-118.4l-66.1-.3c-4.4 0-8 3.5-8 8c0 1.9.7 3.7 1.9 5.2l130.1 155L340.5 670a8.32 8.32 0 0 0-1.9 5.2c0 4.4 3.6 8 8 8l66.1-.3L512 564.4l99.3 118.4l66 .3c4.4 0 8-3.5 8-8c0-1.9-.7-3.7-1.9-5.2L553.5 515l130.1-155c1.2-1.4 1.8-3.3 1.8-5.2z",
      fill: "currentColor"
    }), /*#__PURE__*/vue.createElementVNode("path", {
      d: "M512 65C264.6 65 64 265.6 64 513s200.6 448 448 448s448-200.6 448-448S759.4 65 512 65zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372s372 166.6 372 372s-166.6 372-372 372z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$7 = [_hoisted_2$7];
    function render$7(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$7, _hoisted_3$7);
    }

    script$7.render = render$7;

    var script$6 = {
      name: 'FolderOutlined'
    };

    const _hoisted_1$6 = {
      class: "anticon"
    };
    const _hoisted_2$6 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M880 298.4H521L403.7 186.2a8.15 8.15 0 0 0-5.5-2.2H144c-17.7 0-32 14.3-32 32v592c0 17.7 14.3 32 32 32h736c17.7 0 32-14.3 32-32V330.4c0-17.7-14.3-32-32-32zM840 768H184V256h188.5l119.6 114.4H840V768z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$6 = [_hoisted_2$6];
    function render$6(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$6, _hoisted_3$6);
    }

    script$6.render = render$6;

    var script$5 = {
      name: 'FileOutlined'
    };

    const _hoisted_1$5 = {
      class: "anticon"
    };
    const _hoisted_2$5 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M854.6 288.6L639.4 73.4c-6-6-14.1-9.4-22.6-9.4H192c-17.7 0-32 14.3-32 32v832c0 17.7 14.3 32 32 32h640c17.7 0 32-14.3 32-32V311.3c0-8.5-3.4-16.7-9.4-22.7zM790.2 326H602V137.8L790.2 326zm1.8 562H232V136h302v216a42 42 0 0 0 42 42h216v494z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$5 = [_hoisted_2$5];
    function render$5(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$5, _hoisted_3$5);
    }

    script$5.render = render$5;

    var script$4 = {
      name: 'DeleteOutlined'
    };

    const _hoisted_1$4 = {
      class: "anticon"
    };
    const _hoisted_2$4 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M360 184h-8c4.4 0 8-3.6 8-8v8h304v-8c0 4.4 3.6 8 8 8h-8v72h72v-80c0-35.3-28.7-64-64-64H352c-35.3 0-64 28.7-64 64v80h72v-72zm504 72H160c-17.7 0-32 14.3-32 32v32c0 4.4 3.6 8 8 8h60.4l24.7 523c1.6 34.1 29.8 61 63.9 61h454c34.2 0 62.3-26.8 63.9-61l24.7-523H888c4.4 0 8-3.6 8-8v-32c0-17.7-14.3-32-32-32zM731.3 840H292.7l-24.2-512h487l-24.2 512z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$4 = [_hoisted_2$4];
    function render$4(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$4, _hoisted_3$4);
    }

    script$4.render = render$4;

    var script$3 = {
      name: 'EyeOutlined'
    };

    const _hoisted_1$3 = {
      class: "anticon"
    };
    const _hoisted_2$3 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M942.2 486.2C847.4 286.5 704.1 186 512 186c-192.2 0-335.4 100.5-430.2 300.3a60.3 60.3 0 0 0 0 51.5C176.6 737.5 319.9 838 512 838c192.2 0 335.4-100.5 430.2-300.3c7.7-16.2 7.7-35 0-51.5zM512 766c-161.3 0-279.4-81.8-362.7-254C232.6 339.8 350.7 258 512 258c161.3 0 279.4 81.8 362.7 254C791.5 684.2 673.4 766 512 766zm-4-430c-97.2 0-176 78.8-176 176s78.8 176 176 176s176-78.8 176-176s-78.8-176-176-176zm0 288c-61.9 0-112-50.1-112-112s50.1-112 112-112s112 50.1 112 112s-50.1 112-112 112z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$3 = [_hoisted_2$3];
    function render$3(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$3, _hoisted_3$3);
    }

    script$3.render = render$3;

    function styleInject(css, ref) {
      if ( ref === void 0 ) ref = {};
      var insertAt = ref.insertAt;

      if (!css || typeof document === 'undefined') { return; }

      var head = document.head || document.getElementsByTagName('head')[0];
      var style = document.createElement('style');
      style.type = 'text/css';

      if (insertAt === 'top') {
        if (head.firstChild) {
          head.insertBefore(style, head.firstChild);
        } else {
          head.appendChild(style);
        }
      } else {
        head.appendChild(style);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(document.createTextNode(css));
      }
    }

    var css_248z$1 = "._fc-frame ._fc-files img{display:inline-block;height:100%;vertical-align:top;width:100%}._fc-frame ._fc-upload-cover{background:rgba(0,0,0,.6);bottom:0;left:0;opacity:0;position:absolute;right:0;top:0;transition:opacity .3s}._fc-frame ._fc-upload-cover ._fc-frame-icon{color:#fff;font-size:16px;margin:0 2px}._fc-frame ._fc-files:hover ._fc-upload-cover{opacity:1}._fc-frame .anticon{font-size:16px;width:16px}._fc-frame .ant-upload{display:block}._fc-frame ._fc-frame-icon,._fc-frame ._fc-upload-btn{cursor:pointer}._fc-files,._fc-frame ._fc-upload-btn{background:#fff;border:1px solid #c0ccda;border-radius:4px;box-shadow:2px 2px 5px rgba(0,0,0,.1);box-sizing:border-box;display:inline-block;height:104px;line-height:104px;margin-right:4px;overflow:hidden;position:relative;text-align:center;width:104px}";
    styleInject(css_248z$1);

    function _isSlot$1(s) {
      return typeof s === 'function' || Object.prototype.toString.call(s) === '[object Object]' && !vue.isVNode(s);
    }
    const NAME$4 = 'fcFrame';
    var Frame = vue.defineComponent({
      name: NAME$4,
      props: {
        type: {
          type: String,
          default: 'input'
        },
        field: String,
        helper: {
          type: Boolean,
          default: true
        },
        disabled: {
          type: Boolean,
          default: false
        },
        src: {
          type: String,
          required: true
        },
        icon: {
          type: String,
          default: 'FolderOutlined'
        },
        width: {
          type: [Number, String],
          default: 500
        },
        height: {
          type: String,
          default: '370px'
        },
        maxLength: {
          type: Number,
          default: 0
        },
        okBtnText: {
          type: String,
          default: '确定'
        },
        closeBtnText: {
          type: String,
          default: '关闭'
        },
        modalTitle: String,
        handleIcon: {
          type: [String, Boolean],
          default: undefined
        },
        title: String,
        allowRemove: {
          type: Boolean,
          default: true
        },
        onOpen: {
          type: Function,
          default: () => {}
        },
        onOk: {
          type: Function,
          default: () => {}
        },
        onCancel: {
          type: Function,
          default: () => {}
        },
        onLoad: {
          type: Function,
          default: () => {}
        },
        onBeforeRemove: {
          type: Function,
          default: () => {}
        },
        onRemove: {
          type: Function,
          default: () => {}
        },
        onHandle: Function,
        modal: {
          type: Object,
          default: () => ({})
        },
        srcKey: [String, Number],
        modelValue: [Array, String, Number, Object],
        previewMask: undefined,
        footer: {
          type: Boolean,
          default: true
        },
        reload: {
          type: Boolean,
          default: true
        },
        closeBtn: {
          type: Boolean,
          default: true
        },
        okBtn: {
          type: Boolean,
          default: true
        },
        formCreateInject: Object
      },
      emits: ['update:modelValue', 'change'],
      components: {
        FolderOutlined: script$6,
        EyeOutlined: script$3
      },
      data() {
        return {
          fileList: toArray(this.modelValue),
          previewVisible: false,
          frameVisible: false,
          previewImage: '',
          bus: new Mitt()
        };
      },
      watch: {
        modelValue(n) {
          this.fileList = toArray(n);
        }
      },
      methods: {
        close() {
          this.closeModal(true);
        },
        closeModal(close) {
          this.bus.$emit(close ? '$close' : '$ok');
          if (this.reload) {
            this.bus.$off('$ok');
            this.bus.$off('$close');
          }
          this.frameVisible = false;
        },
        handleCancel() {
          this.previewVisible = false;
        },
        showModal() {
          if (this.disabled || false === this.onOpen()) {
            return;
          }
          this.frameVisible = true;
        },
        input() {
          const n = this.fileList;
          const val = this.maxLength === 1 ? n[0] || '' : n;
          this.$emit('update:modelValue', val);
          this.$emit('change', val);
        },
        makeInput() {
          const Type = vue.resolveComponent(this.icon);
          const slots = {
            addonAfter: () => vue.createVNode(Type, {
              "class": "_fc-frame-icon",
              "onClick": this.showModal
            }, null)
          };
          if (this.fileList.length) {
            slots.suffix = () => vue.createVNode(script$7, {
              "class": "_fc-frame-icon",
              "onClick": () => {
                this.fileList = [];
                this.input();
              }
            }, null);
          }
          return vue.createVNode(vue.resolveComponent("AInput"), {
            "readonly": true,
            "value": this.fileList.map(v => this.getSrc(v)).toString(),
            "key": 1
          }, slots);
        },
        makeGroup(children) {
          if (!this.maxLength || this.fileList.length < this.maxLength) children.push(this.makeBtn());
          return vue.createVNode("div", {
            "key": 2
          }, [children]);
        },
        makeItem(index, children) {
          return vue.createVNode("div", {
            "class": "_fc-files",
            "key": '3' + index
          }, [children]);
        },
        valid(f) {
          const field = this.formCreateInject.field || this.field;
          if (field && f !== field) {
            throw new Error('[frame]无效的字段值');
          }
        },
        makeIcons(val, index) {
          if (this.handleIcon !== false || this.allowRemove === true) {
            const icons = [];
            if (this.type !== 'file' && this.handleIcon !== false || this.type === 'file' && this.handleIcon) icons.push(this.makeHandleIcon(val, index));
            if (this.allowRemove) icons.push(this.makeRemoveIcon(val, index));
            return vue.createVNode("div", {
              "class": "_fc-upload-cover",
              "key": 4
            }, [icons]);
          }
        },
        makeHandleIcon(val, index) {
          const Type = vue.resolveComponent(this.handleIcon === true || this.handleIcon === undefined ? 'EyeOutlined' : this.handleIcon);
          console.log('-> Type', Type);
          return vue.createVNode(Type, {
            "class": "_fc-frame-icon",
            "onClick": () => this.handleClick(val),
            "key": '5' + index
          }, null);
        },
        makeRemoveIcon(val, index) {
          return vue.createVNode(script$4, {
            "class": "_fc-frame-icon",
            "onClick": () => this.handleRemove(val),
            "key": '6' + index
          }, null);
        },
        makeFiles() {
          return this.makeGroup(this.fileList.map((src, index) => {
            return this.makeItem(index, [vue.createVNode(script$5, {
              "class": "_fc-frame-icon",
              "onClick": () => this.handleClick(src)
            }, null), this.makeIcons(src, index)]);
          }));
        },
        makeImages() {
          return this.makeGroup(this.fileList.map((src, index) => {
            return this.makeItem(index, [vue.createVNode("img", {
              "src": this.getSrc(src)
            }, null), this.makeIcons(src, index)]);
          }));
        },
        makeBtn() {
          const Type = vue.resolveComponent(this.icon);
          return vue.createVNode("div", {
            "class": "_fc-upload-btn",
            "onClick": () => this.showModal(),
            "key": 7
          }, [vue.createVNode(Type, {
            "class": "_fc-frame-icon"
          }, null)]);
        },
        handleClick(src) {
          if (this.onHandle) {
            return this.onHandle(src);
          } else {
            this.previewImage = this.getSrc(src);
            this.previewVisible = true;
          }
        },
        handleRemove(src) {
          if (this.disabled) return;
          if (false !== this.onBeforeRemove(src)) {
            this.fileList.splice(this.fileList.indexOf(src), 1);
            this.input();
            this.onRemove(src);
          }
        },
        getSrc(src) {
          return !this.srcKey ? src : src[this.srcKey];
        },
        frameLoad(iframe) {
          this.onLoad(iframe);
          try {
            if (this.helper === true) {
              iframe['form_create_helper'] = {
                api: this.formCreateInject.api,
                close: field => {
                  this.valid(field);
                  this.closeModal();
                },
                set: (field, value) => {
                  this.valid(field);
                  if (!this.disabled) this.$emit('update:modelValue', value);
                },
                get: field => {
                  this.valid(field);
                  return this.modelValue;
                },
                onOk: fn => this.bus.$on('$ok', fn),
                onClose: fn => this.bus.$on('$close', fn)
              };
            }
          } catch (e) {
            console.error(e);
          }
        },
        makeFooter() {
          const {
            okBtnText,
            closeBtnText,
            closeBtn,
            okBtn,
            footer
          } = this.$props;
          const node = [];
          if (!footer) return node;
          if (closeBtn) node.push(vue.createVNode(vue.resolveComponent("AButton"), {
            "onClick": () => this.onCancel() !== false && this.closeModal(true)
          }, _isSlot$1(closeBtnText) ? closeBtnText : {
            default: () => [closeBtnText]
          }));
          if (okBtn) node.push(vue.createVNode(vue.resolveComponent("AButton"), {
            "type": "primary",
            "onClick": () => this.onOk() !== false && this.closeModal()
          }, _isSlot$1(okBtnText) ? okBtnText : {
            default: () => [okBtnText]
          }));
          return node;
        }
      },
      render() {
        const type = this.type;
        let Node;
        if (type === 'input') Node = this.makeInput();else if (type === 'image') Node = this.makeImages();else Node = this.makeFiles();
        const {
          width = '30%',
          height,
          src,
          title,
          modalTitle
        } = this.$props;
        vue.nextTick(() => {
          if (this.$refs.frame) {
            this.frameLoad(this.$refs.frame.contentWindow || {});
          }
        });
        return vue.createVNode("div", {
          "class": "_fc-frame"
        }, [Node, vue.createVNode(vue.resolveComponent("aModal"), {
          "mask": this.previewMask,
          "title": modalTitle,
          "visible": this.previewVisible,
          "onCancel": () => this.previewVisible = false,
          "footer": null
        }, {
          default: () => [vue.createVNode("img", {
            "style": "width: 100%",
            "src": this.previewImage
          }, null)]
        }), vue.createVNode(vue.resolveComponent("aModal"), vue.mergeProps({
          width,
          title,
          ...this.modal
        }, {
          "visible": this.frameVisible,
          "onCancel": () => this.closeModal(true)
        }), {
          default: () => [this.frameVisible || !this.reload ? vue.createVNode("iframe", {
            "ref": "frame",
            "src": src,
            "frameborder": "0",
            "style": {
              height,
              'border': '0 none',
              'width': '100%'
            }
          }, null) : null],
          footer: () => this.makeFooter()
        })]);
      },
      beforeMount() {
        const {
          name,
          field,
          api
        } = this.formCreateInject;
        name && api.on('fc:closeModal:' + name, this.close);
        field && api.on('fc:closeModal:' + field, this.close);
      },
      beforeUnmount() {
        const {
          name,
          field,
          api
        } = this.formCreateInject;
        name && api.off('fc:closeModal:' + name, this.close);
        field && api.off('fc:closeModal:' + field, this.close);
      }
    });

    const is = {
      type(arg, type) {
        return Object.prototype.toString.call(arg) === '[object ' + type + ']';
      },
      Undef(v) {
        return v === undefined || v === null;
      },
      Element(arg) {
        return typeof arg === 'object' && arg !== null && arg.nodeType === 1 && !is.Object(arg);
      },
      trueArray(data) {
        return Array.isArray(data) && data.length > 0;
      },
      Function(v) {
        const type = this.getType(v);
        return type === 'Function' || type === 'AsyncFunction';
      },
      getType(v) {
        const str = Object.prototype.toString.call(v);
        return /^\[object (.*)\]$/.exec(str)[1];
      },
      empty(value) {
        if (value === undefined || value === null) {
          return true;
        }
        if (Array.isArray(value) && Array.isArray(value) && !value.length) {
          return true;
        }
        return typeof value === 'string' && !value;
      }
    };
    ['Date', 'Object', 'String', 'Boolean', 'Array', 'Number'].forEach(t => {
      is[t] = function (arg) {
        return is.type(arg, t);
      };
    });
    function hasProperty(rule, k) {
      return {}.hasOwnProperty.call(rule, k);
    }

    var script$2 = {
      name: 'MinusCircleOutlined'
    };

    const _hoisted_1$2 = {
      class: "anticon"
    };
    const _hoisted_2$2 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M696 480H328c-4.4 0-8 3.6-8 8v48c0 4.4 3.6 8 8 8h368c4.4 0 8-3.6 8-8v-48c0-4.4-3.6-8-8-8z",
      fill: "currentColor"
    }), /*#__PURE__*/vue.createElementVNode("path", {
      d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448s448-200.6 448-448S759.4 64 512 64zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372s372 166.6 372 372s-166.6 372-372 372z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$2 = [_hoisted_2$2];
    function render$2(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$2, _hoisted_3$2);
    }

    script$2.render = render$2;

    var script$1 = {
      name: 'PlusCircleOutlined'
    };

    const _hoisted_1$1 = {
      class: "anticon"
    };
    const _hoisted_2$1 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M696 480H544V328c0-4.4-3.6-8-8-8h-48c-4.4 0-8 3.6-8 8v152H328c-4.4 0-8 3.6-8 8v48c0 4.4 3.6 8 8 8h152v152c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8V544h152c4.4 0 8-3.6 8-8v-48c0-4.4-3.6-8-8-8z",
      fill: "currentColor"
    }), /*#__PURE__*/vue.createElementVNode("path", {
      d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448s448-200.6 448-448S759.4 64 512 64zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372s372 166.6 372 372s-166.6 372-372 372z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3$1 = [_hoisted_2$1];
    function render$1(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1$1, _hoisted_3$1);
    }

    script$1.render = render$1;

    function $set(target, field, value) {
      target[field] = value;
    }
    function $del(target, field) {
      delete target[field];
    }

    function deepExtend(origin, target = {}, mode) {
      let isArr = false;
      for (let key in target) {
        if (Object.prototype.hasOwnProperty.call(target, key)) {
          let clone = target[key];
          if ((isArr = Array.isArray(clone)) || is.Object(clone)) {
            let nst = origin[key] === undefined;
            if (isArr) {
              isArr = false;
              nst && $set(origin, key, []);
            } else if (clone._clone && mode !== undefined) {
              if (mode) {
                clone = clone.getRule();
                nst && $set(origin, key, {});
              } else {
                $set(origin, key, clone._clone());
                continue;
              }
            } else {
              nst && $set(origin, key, {});
            }
            origin[key] = deepExtend(origin[key], clone, mode);
          } else {
            $set(origin, key, clone);
            if (!is.Undef(clone)) {
              if (!is.Undef(clone.__json)) {
                origin[key].__json = clone.__json;
              }
              if (!is.Undef(clone.__origin)) {
                origin[key].__origin = clone.__origin;
              }
            }
          }
        }
      }
      return mode !== undefined && Array.isArray(origin) ? origin.filter(v => !v || !v.__ctrl) : origin;
    }
    function deepCopy(value) {
      return deepExtend({}, {
        value
      }).value;
    }

    const _extends = Object.assign || function (a) {
      for (let b, c = 1; c < arguments.length; c++) {
        for (let d in b = arguments[c], b) {
          Object.prototype.hasOwnProperty.call(b, d) && $set(a, d, b[d]);
        }
      }
      return a;
    };
    function extend() {
      return _extends.apply(this, arguments);
    }

    function _isSlot(s) {
      return typeof s === 'function' || Object.prototype.toString.call(s) === '[object Object]' && !vue.isVNode(s);
    }
    const NAME$3 = 'fcGroup';
    var Group = vue.defineComponent({
      name: NAME$3,
      props: {
        field: String,
        rule: Array,
        expand: Number,
        options: Object,
        button: {
          type: Boolean,
          default: true
        },
        max: {
          type: Number,
          default: 0
        },
        min: {
          type: Number,
          default: 0
        },
        modelValue: {
          type: Array,
          default: () => []
        },
        defaultValue: Object,
        disabled: {
          type: Boolean,
          default: false
        },
        syncDisabled: {
          type: Boolean,
          default: true
        },
        fontSize: {
          type: Number,
          default: 28
        },
        onBeforeRemove: {
          type: Function,
          default: () => {}
        },
        onBeforeAdd: {
          type: Function,
          default: () => {}
        },
        formCreateInject: Object
      },
      data() {
        return {
          len: 0,
          cacheRule: {},
          cacheValue: {},
          form: vue.markRaw(this.formCreateInject.form.$form())
        };
      },
      emits: ['update:modelValue', 'change', 'itemMounted', 'remove', 'add'],
      watch: {
        rule: {
          handler(n, o) {
            Object.keys(this.cacheRule).forEach(v => {
              const item = this.cacheRule[v];
              if (item.$f) {
                const val = item.$f.formData();
                if (n === o) {
                  item.$f.deferSyncValue(() => {
                    deepExtend(item.rule, n);
                    item.$f.setValue(val);
                  }, true);
                } else {
                  const val = item.$f.formData();
                  item.$f.once('reloading', () => {
                    item.$f.setValue(val);
                  });
                  item.rule = deepCopy(n);
                }
              }
            });
          },
          deep: true
        },
        disabled(n) {
          if (this.syncDisabled) {
            const lst = this.cacheRule;
            Object.keys(lst).forEach(k => {
              lst[k].$f.disabled(n);
            });
          }
        },
        expand(n) {
          let d = n - this.modelValue.length;
          if (d > 0) {
            this.expandRule(d);
          }
        },
        modelValue: {
          handler(n) {
            n = n || [];
            let keys = Object.keys(this.cacheRule),
              total = keys.length,
              len = total - n.length;
            if (len < 0) {
              for (let i = len; i < 0; i++) {
                this.addRule(n.length + i, true);
              }
              for (let i = 0; i < total; i++) {
                this.setValue(keys[i], n[i]);
              }
            } else {
              if (len > 0) {
                for (let i = 0; i < len; i++) {
                  this.removeRule(keys[total - i - 1]);
                }
              }
              n.forEach((val, i) => {
                this.setValue(keys[i], n[i]);
              });
            }
          },
          deep: true
        }
      },
      methods: {
        _value(v) {
          return v && hasProperty(v, this.field) ? v[this.field] : v;
        },
        cache(k, val) {
          this.cacheValue[k] = JSON.stringify(val);
        },
        input(value) {
          this.$emit('update:modelValue', value);
          this.$emit('change', value);
        },
        formData(key, formData) {
          const cacheRule = this.cacheRule;
          const keys = Object.keys(cacheRule);
          if (keys.filter(k => cacheRule[k].$f).length !== keys.length) {
            return;
          }
          const value = keys.map(k => {
            const data = key === k ? formData : {
              ...this.cacheRule[k].$f.form
            };
            const value = this.field ? data[this.field] || null : data;
            this.cache(k, value);
            return value;
          });
          this.input(value);
        },
        setValue(key, value) {
          const field = this.field;
          if (field) {
            value = {
              [field]: this._value(value)
            };
          }
          if (this.cacheValue[key] === JSON.stringify(field ? value[field] : value)) {
            return;
          }
          this.cache(key, value);
        },
        addRule(i, emit) {
          const rule = this.formCreateInject.form.copyRules(this.rule || []);
          const options = this.options ? {
            ...this.options
          } : {
            submitBtn: false,
            resetBtn: false
          };
          if (this.defaultValue) {
            if (!options.formData) options.formData = {};
            const defVal = deepCopy(this.defaultValue);
            extend(options.formData, this.field ? {
              [this.field]: defVal
            } : defVal);
          }
          this.cacheRule[++this.len] = {
            rule,
            options
          };
          if (emit) {
            vue.nextTick(() => this.$emit('add', rule, Object.keys(this.cacheRule).length - 1));
          }
        },
        add$f(i, key, $f) {
          this.cacheRule[key].$f = $f;
          this.formData(key, $f.formData());
          vue.nextTick(() => {
            if (this.syncDisabled) {
              $f.disabled(this.disabled);
            }
            this.$emit('itemMounted', $f, Object.keys(this.cacheRule).indexOf(key));
          });
        },
        removeRule(key, emit) {
          const index = Object.keys(this.cacheRule).indexOf(key);
          delete this.cacheRule[key];
          delete this.cacheValue[key];
          if (emit) {
            vue.nextTick(() => this.$emit('remove', index));
          }
        },
        add() {
          if (this.disabled || false === this.onBeforeAdd(this.modelValue)) {
            return;
          }
          this.modelValue.push(this.field ? null : {});
          this.$emit('update:modelValue', this.modelValue);
        },
        del(index, key) {
          if (this.disabled || false === this.onBeforeRemove(this.modelValue, index)) {
            return;
          }
          this.removeRule(key, true);
          this.modelValue.splice(index, 1);
          this.input(this.modelValue);
        },
        addIcon(key) {
          return vue.createVNode(script$1, {
            "key": `a${key}`,
            "style": `font-size:${this.fontSize}px;cursor:${this.disabled ? 'not-allowed;color:#c9cdd4' : 'pointer'};`,
            "onClick": this.add
          }, null);
        },
        delIcon(index, key) {
          return vue.createVNode(script$2, {
            "key": `d${key}`,
            "style": `font-size:${this.fontSize}px;cursor:${this.disabled ? 'not-allowed;color:#c9cdd4' : 'pointer;color:#606266'};`,
            "onClick": () => this.del(index, key)
          }, null);
        },
        makeIcon(total, index, key) {
          if (this.$slots.button) {
            return this.$slots.button({
              total,
              index,
              vm: this,
              key,
              del: () => this.del(index, key),
              add: this.add
            });
          }
          if (index === 0) {
            return [this.max !== 0 && total >= this.max ? null : this.addIcon(key), this.min === 0 || total > this.min ? this.delIcon(index, key) : null];
          }
          if (index >= this.min) {
            return this.delIcon(index, key);
          }
        },
        emitEvent(name, args, index, key) {
          this.$emit(name, ...args, this.cacheRule[key].$f, index);
        },
        expandRule(n) {
          for (let i = 0; i < n; i++) {
            this.modelValue.push(this.field ? null : {});
          }
        }
      },
      created() {
        const d = (this.expand || 0) - this.modelValue.length;
        for (let i = 0; i < this.modelValue.length; i++) {
          this.addRule(i);
        }
        if (d > 0) {
          this.expandRule(d);
        }
      },
      render() {
        const keys = Object.keys(this.cacheRule);
        const button = this.button;
        const Type = this.form;
        return keys.length === 0 ? this.$slots.default ? this.$slots.default({
          vm: this,
          add: this.add
        }) : vue.createVNode(script$1, {
          "key": 1,
          "style": `font-size:${this.fontSize}px;vertical-align:middle;color:${this.disabled ? '#c9cdd4;cursor: not-allowed' : '#606266;cursor:pointer'};`,
          "onClick": this.add
        }, null) : vue.createVNode("div", {
          "key": 2
        }, [keys.map((key, index) => {
          let _slot;
          const {
            rule,
            options
          } = this.cacheRule[key];
          return vue.createVNode(vue.resolveComponent("aRow"), {
            "align": "middle",
            "type": "flex",
            "key": key,
            "style": "border-bottom:1px dashed #DCDFE6;margin-bottom:10px;"
          }, {
            default: () => [vue.createVNode(vue.resolveComponent("aCol"), {
              "span": button ? 20 : 24
            }, {
              default: () => [vue.createVNode(Type, {
                "key": key,
                "inFor": true,
                "onUpdate:modelValue": formData => this.formData(key, formData),
                "modelValue": this.field ? {
                  [this.field]: this._value(this.modelValue[index])
                } : this.modelValue[index],
                "onEmit-event": (name, ...args) => this.emitEvent(name, args, index, key),
                "onUpdate:api": $f => this.add$f(index, key, $f),
                "rule": rule,
                "option": options,
                "extendOption": true
              }, null)]
            }), button ? vue.createVNode(vue.resolveComponent("aCol"), {
              "span": 2,
              "pull": 1,
              "push": 1
            }, _isSlot(_slot = this.makeIcon(keys.length, index, key)) ? _slot : {
              default: () => [_slot]
            }) : null]
          });
        })]);
      }
    });

    const NAME$2 = 'fcSubForm';
    var Sub = vue.defineComponent({
      name: NAME$2,
      props: {
        rule: Array,
        options: {
          type: Object,
          default: () => vue.reactive({
            submitBtn: false,
            resetBtn: false
          })
        },
        modelValue: {
          type: Object,
          default: () => ({})
        },
        disabled: {
          type: Boolean,
          default: false
        },
        syncDisabled: {
          type: Boolean,
          default: true
        },
        formCreateInject: Object
      },
      data() {
        return {
          cacheValue: {},
          subApi: {},
          form: vue.markRaw(this.formCreateInject.form.$form())
        };
      },
      emits: ['fc:subform', 'update:modelValue', 'change', 'itemMounted'],
      watch: {
        disabled(n) {
          this.syncDisabled && this.subApi.disabled(n);
        },
        modelValue(n) {
          this.setValue(n);
        }
      },
      methods: {
        formData(value) {
          this.cacheValue = JSON.stringify(value);
          this.$emit('update:modelValue', value);
          this.$emit('change', value);
        },
        setValue(value) {
          const str = JSON.stringify(value);
          if (this.cacheValue === str) {
            return;
          }
          this.cacheValue = str;
          this.subApi.coverValue(value || {});
        },
        add$f(api) {
          this.subApi = api;
          vue.nextTick(() => {
            this.syncDisabled && api.disabled(this.disabled);
            this.$emit('itemMounted', api);
          });
        }
      },
      render() {
        const Type = this.form;
        return vue.createVNode(Type, {
          "onUpdate:modelValue": this.formData,
          "modelValue": this.modelValue,
          "onEmit-event": this.$emit,
          "onUpdate:api": this.add$f,
          "rule": this.rule,
          "option": this.options,
          "extendOption": true
        }, null);
      }
    });

    var script = {
      name: 'QuestionCircleOutlined'
    };

    const _hoisted_1 = {
      class: "anticon"
    };
    const _hoisted_2 = /*#__PURE__*/vue.createElementVNode("svg", {
      height: "1em",
      width: "1em",
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 1024 1024"
    }, [/*#__PURE__*/vue.createElementVNode("path", {
      d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448s448-200.6 448-448S759.4 64 512 64zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372s372 166.6 372 372s-166.6 372-372 372z",
      fill: "currentColor"
    }), /*#__PURE__*/vue.createElementVNode("path", {
      d: "M623.6 316.7C593.6 290.4 554 276 512 276s-81.6 14.5-111.6 40.7C369.2 344 352 380.7 352 420v7.6c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8V420c0-44.1 43.1-80 96-80s96 35.9 96 80c0 31.1-22 59.6-56.1 72.7c-21.2 8.1-39.2 22.3-52.1 40.9c-13.1 19-19.9 41.8-19.9 64.9V620c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8v-22.7a48.3 48.3 0 0 1 30.9-44.8c59-22.7 97.1-74.7 97.1-132.5c.1-39.3-17.1-76-48.3-103.3zM472 732a40 40 0 1 0 80 0a40 40 0 1 0-80 0z",
      fill: "currentColor"
    })], -1);
    const _hoisted_3 = [_hoisted_2];
    function render(_ctx, _cache, $props, $setup, $data, $options) {
      return vue.openBlock(), vue.createElementBlock("span", _hoisted_1, _hoisted_3);
    }

    script.render = render;

    var components = [Upload, Frame, Group, Sub, script];

    var checkbox = {
      name: 'checkbox',
      modelField: 'value',
      mergeProp(ctx) {
        const props = ctx.prop.props;
        if (!hasProperty(props, 'options')) props.options = ctx.prop.options || [];
      }
    };

    var radio = {
      ...checkbox,
      name: 'radio'
    };

    var select = {
      ...checkbox,
      name: 'select'
    };

    const NAME$1 = 'FormCreate';
    const getRuleInject = (vm, parent) => {
      if (!vm || vm === parent) {
        return;
      }
      if (vm.props.formCreateInject) {
        return vm.props.formCreateInject;
      }
      if (vm.parent) {
        return getRuleInject(vm.parent, parent);
      }
    };
    function $FormCreate(FormCreate) {
      return vue.defineComponent({
        name: NAME$1,
        props: {
          rule: {
            type: Array,
            required: true,
            default: () => []
          },
          option: {
            type: Object,
            default: () => ({})
          },
          extendOption: Boolean,
          modelValue: Object,
          api: Object,
          name: String,
          subForm: {
            type: Boolean,
            default: true
          },
          inFor: Boolean
        },
        emits: ['update:api', 'update:modelValue', 'mounted', 'submit', 'change', 'emit-event', 'control', 'remove-rule', 'remove-field', 'sync', 'reload', 'repeat-field', 'update'],
        render() {
          return this.fc.render();
        },
        setup(props) {
          const vm = vue.getCurrentInstance();
          vue.provide('parentFC', vm);
          const parent = vue.inject('parentFC', null);
          const {
            rule,
            modelValue,
            subForm,
            inFor
          } = vue.toRefs(props);
          const data = vue.reactive({
            ctxInject: {},
            destroyed: false,
            isShow: true,
            unique: 1,
            renderRule: [...(rule.value || [])],
            updateValue: JSON.stringify(modelValue || {})
          });
          const fc = new FormCreate(vm);
          const fapi = fc.api();
          const isMore = inFor.value;
          const addSubForm = () => {
            if (parent) {
              const inject = getRuleInject(vm, parent);
              if (inject) {
                let sub;
                if (isMore) {
                  sub = toArray(inject.getSubForm());
                  sub.push(fapi);
                } else {
                  sub = fapi;
                }
                inject.subForm(sub);
              }
            }
          };
          const rmSubForm = () => {
            const inject = getRuleInject(vm, parent);
            if (inject) {
              if (isMore) {
                const sub = toArray(inject.getSubForm());
                const idx = sub.indexOf(fapi);
                if (idx > -1) {
                  sub.splice(idx, 1);
                }
              } else {
                inject.subForm();
              }
            }
          };
          vue.onMounted(() => {
            fc.mounted();
          });
          vue.onBeforeUnmount(() => {
            rmSubForm();
            data.destroyed = true;
            fc.unmount();
          });
          vue.onUpdated(() => {
            fc.updated();
          });
          vue.watch(subForm, n => {
            n ? addSubForm() : rmSubForm();
          }, {
            immediate: true
          });
          vue.watch(() => [...rule.value], n => {
            if (fc.$handle.isBreakWatch() || n.length === data.renderRule.length && n.every(v => data.renderRule.indexOf(v) > -1)) return;
            fc.$handle.reloadRule(rule.value);
            vm.setupState.renderRule();
          });
          vue.watch(() => props.option, n => {
            fc.initOptions(n);
            fapi.refresh();
          }, {
            deep: true
          });
          vue.watch(modelValue, n => {
            if (JSON.stringify(n || {}) === data.updateValue) return;
            fapi.config.forceCoverValue ? fapi.coverValue(n || {}) : fapi.setValue(n || {});
          }, {
            deep: true
          });
          return {
            fc: vue.markRaw(fc),
            parent: parent ? vue.markRaw(parent) : parent,
            fapi: vue.markRaw(fapi),
            ...vue.toRefs(data),
            refresh() {
              ++data.unique;
            },
            renderRule() {
              data.renderRule = [...(rule.value || [])];
            },
            updateValue(value) {
              if (data.destroyed) return;
              data.updateValue = JSON.stringify(value);
              vm.emit('update:modelValue', value);
            }
          };
        },
        created() {
          const vm = vue.getCurrentInstance();
          vm.setupState.fc.init();
          vm.emit('update:api', vm.setupState.fapi);
        }
      });
    }

    const normalMerge = ['props'];
    const toArrayMerge = ['class', 'style', 'directives'];
    const functionalMerge = ['on'];
    const mergeProps = (objects, initial = {}, opt = {}) => {
      const _normalMerge = [...normalMerge, ...(opt['normal'] || [])];
      const _toArrayMerge = [...toArrayMerge, ...(opt['array'] || [])];
      const _functionalMerge = [...functionalMerge, ...(opt['functional'] || [])];
      const propsMerge = opt['props'] || [];
      return objects.reduce((a, b) => {
        for (const key in b) {
          if (a[key]) {
            if (propsMerge.indexOf(key) > -1) {
              a[key] = mergeProps([b[key]], a[key]);
            } else if (_normalMerge.indexOf(key) > -1) {
              a[key] = {
                ...a[key],
                ...b[key]
              };
            } else if (_toArrayMerge.indexOf(key) > -1) {
              const arrA = a[key] instanceof Array ? a[key] : [a[key]];
              const arrB = b[key] instanceof Array ? b[key] : [b[key]];
              a[key] = [...arrA, ...arrB];
            } else if (_functionalMerge.indexOf(key) > -1) {
              for (const event in b[key]) {
                if (a[key][event]) {
                  const arrA = a[key][event] instanceof Array ? a[key][event] : [a[key][event]];
                  const arrB = b[key][event] instanceof Array ? b[key][event] : [b[key][event]];
                  a[key][event] = [...arrA, ...arrB];
                } else {
                  a[key][event] = b[key][event];
                }
              }
            } else if (key === 'hook') {
              for (let hook in b[key]) {
                if (a[key][hook]) {
                  a[key][hook] = mergeFn(a[key][hook], b[key][hook]);
                } else {
                  a[key][hook] = b[key][hook];
                }
              }
            } else {
              a[key] = b[key];
            }
          } else {
            if (_normalMerge.indexOf(key) > -1 || _functionalMerge.indexOf(key) > -1 || propsMerge.indexOf(key) > -1) {
              a[key] = {
                ...b[key]
              };
            } else if (_toArrayMerge.indexOf(key) > -1) {
              a[key] = b[key] instanceof Array ? [...b[key]] : typeof b[key] === 'object' ? {
                ...b[key]
              } : b[key];
            } else a[key] = b[key];
          }
        }
        return a;
      }, initial);
    };
    const mergeFn = (fn1, fn2) => function () {
      fn1 && fn1.apply(this, arguments);
      fn2 && fn2.apply(this, arguments);
    };

    const keyAttrs = ['type', 'slot', 'emitPrefix', 'value', 'name', 'native', 'hidden', 'display', 'inject', 'options', 'emit', 'link', 'prefix', 'suffix', 'update', 'sync', 'optionsTo', 'key', 'slotUpdate', 'computed', 'preview', 'component', 'cache'];
    const arrayAttrs = ['validate', 'children', 'control'];
    const normalAttrs = ['effect'];
    function attrs() {
      return [...keyAttrs, ...normalMerge, ...toArrayMerge, ...functionalMerge, ...arrayAttrs, ...normalAttrs];
    }

    function format(type, msg, rule) {
      return `[form-create ${type}]: ${msg}` + (rule ? '\n\nrule: ' + JSON.stringify(rule.getRule ? rule.getRule() : rule) : '');
    }
    function err(msg, rule) {
      console.error(format('err', msg, rule));
    }
    function logError(e) {
      err(e.toString());
      console.error(e);
    }

    function toLine(name) {
      let line = name.replace(/([A-Z])/g, '-$1').toLocaleLowerCase();
      if (line.indexOf('-') === 0) line = line.substr(1);
      return line;
    }
    function upper(str) {
      return str.replace(str[0], str[0].toLocaleUpperCase());
    }

    const PREFIX = '[[FORM-CREATE-PREFIX-';
    const SUFFIX = '-FORM-CREATE-SUFFIX]]';
    const $T = '$FN:';
    const $TX = '$FNX:';
    const FUNCTION = 'function';
    function toJson(obj, space) {
      return JSON.stringify(deepExtend([], obj, true), function (key, val) {
        if (val && val._isVue === true) return undefined;
        if (typeof val !== FUNCTION) {
          return val;
        }
        if (val.__json) {
          return val.__json;
        }
        if (val.__origin) val = val.__origin;
        if (val.__emit) return undefined;
        return PREFIX + val + SUFFIX;
      }, space);
    }
    function makeFn(fn) {
      return eval('(' + FUNCTION + '(){return ' + fn + ' })()');
    }
    function parseFn(fn, mode) {
      if (fn && is.String(fn) && fn.length > 4) {
        let v = fn.trim();
        let flag = false;
        try {
          if (v.indexOf(SUFFIX) > 0 && v.indexOf(PREFIX) === 0) {
            v = v.replace(SUFFIX, '').replace(PREFIX, '');
            flag = true;
          } else if (v.indexOf($T) === 0) {
            v = v.replace($T, '');
            flag = true;
          } else if (v.indexOf($TX) === 0) {
            v = makeFn('function($inject){' + v.replace($TX, '') + '}');
            v.__json = fn;
            v.__inject = true;
            return v;
          } else if (!mode && v.indexOf(FUNCTION) === 0 && v !== FUNCTION) {
            flag = true;
          }
          if (!flag) return fn;
          const val = makeFn(v.indexOf(FUNCTION) === -1 && v.indexOf('(') !== 0 ? FUNCTION + ' ' + v : v);
          val.__json = fn;
          return val;
        } catch (e) {
          err(`解析失败:${v}\n\nerr: ${e}`);
          return undefined;
        }
      }
      return fn;
    }
    function parseJson(json, mode) {
      return JSON.parse(json, function (k, v) {
        if (is.Undef(v) || !v.indexOf) return v;
        return parseFn(v, mode);
      });
    }

    function enumerable(value, writable) {
      return {
        value,
        enumerable: false,
        configurable: false,
        writable: !!writable
      };
    }

    //todo 优化位置
    function copyRule(rule, mode) {
      return copyRules([rule], mode || false)[0];
    }
    function copyRules(rules, mode) {
      return deepExtend([], [...rules], mode || false);
    }
    function mergeRule(rule, merge) {
      mergeProps(Array.isArray(merge) ? merge : [merge], rule, {
        array: arrayAttrs,
        normal: normalAttrs
      });
      return rule;
    }
    function getRule(rule) {
      const r = is.Function(rule.getRule) ? rule.getRule() : rule;
      if (!r.type) {
        r.type = 'input';
      }
      return r;
    }
    function mergeGlobal(target, merge) {
      if (!target) return merge;
      Object.keys(merge || {}).forEach(k => {
        if (merge[k]) {
          target[k] = mergeRule(target[k] || {}, merge[k]);
        }
      });
      return target;
    }
    function funcProxy(that, proxy) {
      Object.defineProperties(that, Object.keys(proxy).reduce((initial, k) => {
        initial[k] = {
          get() {
            return proxy[k]();
          }
        };
        return initial;
      }, {}));
    }
    function byCtx(rule) {
      return rule.__fc__ || (rule.__origin__ ? rule.__origin__.__fc__ : null);
    }
    function invoke(fn, def) {
      try {
        def = fn();
      } catch (e) {
        logError(e);
      }
      return def;
    }
    function makeSlotBag() {
      const slotBag = {};
      const slotName = n => n || 'default';
      return {
        setSlot(slot, vnFn) {
          slot = slotName(slot);
          if (!vnFn || Array.isArray(vnFn) && vnFn.length) return;
          if (!slotBag[slot]) slotBag[slot] = [];
          slotBag[slot].push(vnFn);
        },
        getSlot(slot, val) {
          slot = slotName(slot);
          const children = [];
          (slotBag[slot] || []).forEach(fn => {
            if (Array.isArray(fn)) {
              children.push(...fn);
            } else if (is.Function(fn)) {
              const res = fn(...(val || []));
              if (Array.isArray(res)) {
                children.push(...res);
              } else {
                children.push(res);
              }
            } else if (!is.Undef(fn)) {
              children.push(fn);
            }
          });
          return children;
        },
        getSlots() {
          const slots = {};
          Object.keys(slotBag).forEach(k => {
            slots[k] = (...args) => {
              return this.getSlot(k, args);
            };
          });
          return slots;
        },
        slotLen(slot) {
          slot = slotName(slot);
          return slotBag[slot] ? slotBag[slot].length : 0;
        },
        mergeBag(bag) {
          if (!bag) return this;
          const slots = is.Function(bag.getSlots) ? bag.getSlots() : bag;
          if (Array.isArray(bag) || vue.isVNode(bag)) {
            this.setSlot(undefined, () => bag);
          } else {
            Object.keys(slots).forEach(k => {
              this.setSlot(k, slots[k]);
            });
          }
          return this;
        }
      };
    }
    function toProps(rule) {
      const prop = {
        ...(rule.props || {})
      };
      Object.keys(rule.on || {}).forEach(k => {
        const name = `on${upper(k)}`;
        if (Array.isArray(prop[name])) {
          prop[name] = [...prop[name], rule.on[k]];
        } else if (prop[name]) {
          prop[name] = [prop[name], rule.on[k]];
        } else {
          prop[name] = rule.on[k];
        }
      });
      prop.key = rule.key;
      prop.ref = rule.ref;
      prop.class = rule.class;
      prop.style = rule.style;
      if (prop.slot) delete prop.slot;
      return prop;
    }

    function baseRule() {
      return {
        props: {},
        on: {},
        options: [],
        children: [],
        hidden: false,
        display: true,
        value: undefined
      };
    }
    function creatorFactory(name, init) {
      return (title, field, value, props = {}) => {
        const maker = new Creator(name, title, field, value, props);
        if (init) {
          if (is.Function(init)) init(maker);else maker.props(init);
        }
        return maker;
      };
    }
    function Creator(type, title, field, value, props) {
      this._data = extend(baseRule(), {
        type,
        title,
        field,
        value,
        props: props || {}
      });
      this.event = this.on;
    }
    extend(Creator.prototype, {
      getRule() {
        return this._data;
      },
      setProp(key, value) {
        $set(this._data, key, value);
        return this;
      },
      modelField(field) {
        this._data.modelField = field;
        return this;
      },
      _clone() {
        const clone = new this.constructor();
        clone._data = copyRule(this._data);
        return clone;
      }
    });
    function appendProto(attrs) {
      attrs.forEach(name => {
        Creator.prototype[name] = function (key) {
          mergeRule(this._data, {
            [name]: arguments.length < 2 ? key : {
              [key]: arguments[1]
            }
          });
          return this;
        };
      });
    }
    appendProto(attrs());

    const commonMaker = creatorFactory('');
    function create(type, field, title) {
      let make = commonMaker('', field);
      make._data.type = type;
      make._data.title = title;
      return make;
    }
    function makerFactory() {
      return {
        create,
        factory: creatorFactory
      };
    }

    function copy(value) {
      return deepCopy(value);
    }
    function Api(h) {
      function tidyFields(fields) {
        if (is.Undef(fields)) fields = h.fields();else if (!Array.isArray(fields)) fields = [fields];
        return fields;
      }
      function props(fields, key, val) {
        tidyFields(fields).forEach(field => {
          h.getCtxs(field).forEach(ctx => {
            $set(ctx.rule, key, val);
            h.$render.clearCache(ctx);
          });
        });
      }
      function allSubForm() {
        const subs = h.subForm;
        return Object.keys(subs).reduce((initial, k) => {
          const sub = subs[k];
          if (!sub) return initial;
          if (Array.isArray(sub)) initial.push(...sub);else initial.push(sub);
          return initial;
        }, []);
      }
      const api = {
        get config() {
          return h.options;
        },
        set config(val) {
          h.fc.options.value = val;
        },
        get options() {
          return h.options;
        },
        set options(val) {
          h.fc.options.value = val;
        },
        get form() {
          return h.form;
        },
        get rule() {
          return h.rules;
        },
        get parent() {
          return h.vm.parent && h.vm.parent.setupState.fapi;
        },
        get children() {
          return allSubForm();
        },
        formData(fields) {
          return tidyFields(fields).reduce((initial, id) => {
            const ctx = h.getFieldCtx(id);
            if (!ctx) return initial;
            initial[ctx.field] = copy(ctx.rule.value);
            return initial;
          }, {});
        },
        getValue(field) {
          const ctx = h.getFieldCtx(field);
          if (!ctx) return;
          return copy(ctx.rule.value);
        },
        coverValue(formData) {
          const data = {
            ...(formData || {})
          };
          h.deferSyncValue(() => {
            api.fields().forEach(key => {
              const ctxs = h.fieldCtx[key];
              if (ctxs) {
                const flag = hasProperty(formData, key);
                ctxs.forEach(ctx => {
                  ctx.rule.value = flag ? formData[key] : undefined;
                });
                delete data[key];
              }
            });
            extend(h.appendData, data);
          });
        },
        setValue(field) {
          let formData = field;
          if (arguments.length >= 2) formData = {
            [field]: arguments[1]
          };
          h.deferSyncValue(() => {
            Object.keys(formData).forEach(key => {
              const ctxs = h.fieldCtx[key];
              if (!ctxs) return h.appendData[key] = formData[key];
              ctxs.forEach(ctx => {
                ctx.rule.value = formData[key];
              });
            });
          });
        },
        removeField(field) {
          const ctx = h.getCtx(field);
          h.deferSyncValue(() => {
            h.getCtxs(field).forEach(ctx => {
              ctx.rm();
            });
          }, true);
          return ctx ? ctx.origin : undefined;
        },
        removeRule(rule) {
          const ctx = rule && byCtx(rule);
          if (!ctx) return;
          ctx.rm();
          return ctx.origin;
        },
        fields: () => h.fields(),
        append: (rule, after, child) => {
          let index = h.sort.length - 1,
            rules;
          const ctx = h.getCtx(after);
          if (ctx) {
            if (child) {
              rules = ctx.getPending('children', ctx.rule.children);
              if (!Array.isArray(rules)) return;
              index = ctx.rule.children.length - 1;
            } else {
              index = ctx.root.indexOf(ctx.origin);
              rules = ctx.root;
            }
          } else rules = h.rules;
          rules.splice(index + 1, 0, rule);
        },
        prepend: (rule, after, child) => {
          let index = 0,
            rules;
          const ctx = h.getCtx(after);
          if (ctx) {
            if (child) {
              rules = ctx.getPending('children', ctx.rule.children);
              if (!Array.isArray(rules)) return;
            } else {
              index = ctx.root.indexOf(ctx.origin);
              rules = ctx.root;
            }
          } else rules = h.rules;
          rules.splice(index, 0, rule);
        },
        hidden(state, fields) {
          props(fields, 'hidden', !!state);
          h.refresh();
        },
        hiddenStatus(id) {
          const ctx = h.getCtx(id);
          if (!ctx) return;
          return !!ctx.rule.hidden;
        },
        display(state, fields) {
          props(fields, 'display', !!state);
          h.refresh();
        },
        displayStatus(id) {
          const ctx = h.getCtx(id);
          if (!ctx) return;
          return !!ctx.rule.display;
        },
        disabled(disabled, fields) {
          tidyFields(fields).forEach(field => {
            h.getCtxs(field).forEach(ctx => {
              $set(ctx.rule.props, 'disabled', !!disabled);
            });
          });
          h.refresh();
        },
        all(origin) {
          return Object.keys(h.ctxs).map(k => {
            const ctx = h.ctxs[k];
            return origin ? ctx.origin : ctx.rule;
          });
        },
        model(origin) {
          return h.fields().reduce((initial, key) => {
            const ctx = h.fieldCtx[key][0];
            initial[key] = origin ? ctx.origin : ctx.rule;
            return initial;
          }, {});
        },
        component(origin) {
          return Object.keys(h.nameCtx).reduce((initial, key) => {
            const ctx = h.nameCtx[key].map(ctx => origin ? ctx.origin : ctx.rule);
            initial[key] = ctx.length === 1 ? ctx[0] : ctx;
            return initial;
          }, {});
        },
        bind() {
          return api.form;
        },
        reload: rules => {
          h.reloadRule(rules);
        },
        updateOptions(options) {
          h.fc.updateOptions(options);
          api.refresh();
        },
        onSubmit(fn) {
          api.updateOptions({
            onSubmit: fn
          });
        },
        sync: field => {
          if (Array.isArray(field)) {
            field.forEach(v => api.sync(v));
            return;
          }
          let ctxs = is.Object(field) ? byCtx(field) : h.getCtxs(field);
          if (!ctxs) {
            return;
          }
          ctxs = Array.isArray(ctxs) ? ctxs : [ctxs];
          ctxs.forEach(ctx => {
            if (!ctx.deleted) {
              const subForm = h.subForm[ctx.id];
              if (subForm) {
                if (Array.isArray(subForm)) {
                  subForm.forEach(form => {
                    form.refresh();
                  });
                } else if (subForm) {
                  subForm.refresh();
                }
              }
              //ctx.updateKey(true);
              h.$render.clearCache(ctx);
            }
          });
          h.refresh();
        },
        refresh: () => {
          allSubForm().forEach(sub => {
            sub.refresh();
          });
          h.$render.clearCacheAll();
          h.refresh();
        },
        refreshOptions() {
          h.$manager.updateOptions(h.options);
          api.refresh();
        },
        hideForm: hide => {
          h.vm.setupState.isShow = !hide;
        },
        changeStatus: () => {
          return h.changeStatus;
        },
        clearChangeStatus: () => {
          h.changeStatus = false;
        },
        updateRule(id, rule) {
          h.getCtxs(id).forEach(ctx => {
            extend(ctx.rule, rule);
          });
        },
        updateRules(rules) {
          Object.keys(rules).forEach(id => {
            api.updateRule(id, rules[id]);
          });
        },
        mergeRule: (id, rule) => {
          h.getCtxs(id).forEach(ctx => {
            mergeRule(ctx.rule, rule);
          });
        },
        mergeRules(rules) {
          Object.keys(rules).forEach(id => {
            api.mergeRule(id, rules[id]);
          });
        },
        getRule: (id, origin) => {
          const ctx = h.getCtx(id);
          if (ctx) {
            return origin ? ctx.origin : ctx.rule;
          }
        },
        setEffect(id, attr, value) {
          const ctx = h.getCtx(id);
          if (ctx && attr) {
            if (attr[0] === '$') {
              attr = attr.substr(1);
            }
            if (hasProperty(ctx.rule, '$' + attr)) {
              $set(ctx.rule, '$' + attr, value);
            }
            if (!hasProperty(ctx.rule, 'effect')) {
              ctx.rule.effect = {};
            }
            $set(ctx.rule.effect, attr, value);
          }
        },
        clearEffectData(id, attr) {
          const ctx = h.getCtx(id);
          if (ctx) {
            if (attr && attr[0] === '$') {
              attr = attr.substr(1);
            }
            ctx.clearEffectData(attr);
            api.sync(id);
          }
        },
        updateValidate(id, validate, merge) {
          if (merge) {
            api.mergeRule(id, {
              validate
            });
          } else {
            props(id, 'validate', validate);
          }
        },
        updateValidates(validates, merge) {
          Object.keys(validates).forEach(id => {
            api.updateValidate(id, validates[id], merge);
          });
        },
        refreshValidate() {
          api.refresh();
        },
        resetFields(fields) {
          tidyFields(fields).forEach(field => {
            h.getCtxs(field).forEach(ctx => {
              h.$render.clearCache(ctx);
              ctx.rule.value = copy(ctx.defaultValue);
            });
          });
        },
        method(id, name) {
          const el = api.el(id);
          if (!el || !el[name]) throw new Error(format('err', `${name}方法不存在`));
          return (...args) => {
            return el[name](...args);
          };
        },
        exec(id, name, ...args) {
          return invoke(() => api.method(id, name)(...args));
        },
        toJson(space) {
          return toJson(api.rule, space);
        },
        trigger(id, event, ...args) {
          const el = api.el(id);
          el && el.$emit(event, ...args);
        },
        el(id) {
          const ctx = h.getCtx(id);
          if (ctx) return ctx.el || h.vm.refs[ctx.ref];
        },
        closeModal: id => {
          h.bus.$emit('fc:closeModal:' + id);
        },
        getSubForm(field) {
          const ctx = h.getCtx(field);
          return ctx ? h.subForm[ctx.id] : undefined;
        },
        nextTick(fn) {
          h.bus.$once('next-tick', fn);
          h.refresh();
        },
        nextRefresh(fn) {
          h.nextRefresh();
          fn && invoke(fn);
        },
        deferSyncValue(fn, sync) {
          h.deferSyncValue(fn, sync);
        },
        emit(name, ...args) {
          h.vm.emit(name, ...args);
        },
        helper: {
          tidyFields,
          props
        }
      };
      ['on', 'once', 'off', 'set'].forEach(n => {
        api[n] = function (...args) {
          h.bus[`$${n}`](...args);
        };
      });
      api.changeValue = api.changeField = api.setValue;
      return api;
    }

    function useCache(Render) {
      extend(Render.prototype, {
        initCache() {
          this.clearCacheAll();
        },
        clearCache(ctx) {
          if (!this.cache[ctx.id]) {
            ctx.parent && this.clearCache(ctx.parent);
            return;
          }
          if (this.cache[ctx.id].use === true || this.cache[ctx.id].parent) {
            this.$handle.refresh();
          }
          const parent = this.cache[ctx.id].parent;
          this.cache[ctx.id] = null;
          parent && this.clearCache(parent);
        },
        clearCacheAll() {
          this.cache = {};
        },
        setCache(ctx, vnode, parent) {
          this.cache[ctx.id] = {
            vnode,
            use: false,
            parent,
            slot: ctx.rule.slot
          };
        },
        getCache(ctx) {
          const cache = this.cache[ctx.id];
          if (cache) {
            cache.use = true;
            return cache.vnode;
          }
          return undefined;
        }
      });
    }

    function toCase(str) {
      const to = str.replace(/(-[a-z])/g, function (v) {
        return v.replace('-', '').toLocaleUpperCase();
      });
      return lower(to);
    }
    function lower(str) {
      return str.replace(str[0], str[0].toLowerCase());
    }

    function toString(val) {
      return val == null ? '' : typeof val === 'object' ? JSON.stringify(val, null, 2) : String(val);
    }

    let id$2 = 0;
    function uniqueId() {
      return 'F' + Math.random().toString(36).substr(3, 3) + Number(`${Date.now()}${++id$2}`).toString(36);
    }

    function deepSet(data, idx, val) {
      let _data = data,
        to;
      (idx || '').split('.').forEach(v => {
        if (to) {
          if (!_data[to] || typeof _data[to] != 'object') {
            _data[to] = {};
          }
          _data = _data[to];
        }
        to = v;
      });
      _data[to] = val;
      return _data;
    }

    function useRender$1(Render) {
      extend(Render.prototype, {
        initRender() {
          this.cacheConfig = {};
        },
        getTypeSlot(type) {
          const name = 'type-' + toLine(type);
          const _fn = vm => {
            if (vm) {
              const slot = vm.slots[name] || vm.slots['type-' + type];
              if (slot) {
                return slot;
              }
              return _fn(vm.setupState.parent);
            }
          };
          return _fn(this.vm);
        },
        render() {
          // console.warn('renderrrrr', this.id);
          if (!this.vm.setupState.isShow) {
            return;
          }
          this.$manager.beforeRender();
          const slotBag = makeSlotBag();
          this.sort.forEach(k => {
            this.renderSlot(slotBag, this.$handle.ctxs[k]);
          });
          return this.$manager.render(slotBag);
        },
        renderSlot(slotBag, ctx, parent) {
          if (this.isFragment(ctx)) {
            ctx.initProp();
            this.mergeGlobal(ctx);
            ctx.initNone();
            const slots = this.renderChildren(ctx.loadChildrenPending(), ctx);
            const def = slots.default;
            def && slotBag.setSlot(ctx.rule.slot, () => def());
            delete slots.default;
            slotBag.mergeBag(slots);
          } else {
            slotBag.setSlot(ctx.rule.slot, this.renderCtx(ctx, parent));
          }
        },
        mergeGlobal(ctx) {
          const g = this.$handle.options.global;
          if (!g) return;
          if (!this.cacheConfig[ctx.trueType]) {
            this.cacheConfig[ctx.trueType] = vue.computed(() => {
              const g = this.$handle.options.global;
              return mergeRule({}, [g['*'], g[ctx.originType] || g[ctx.type] || g[ctx.type] || {}]);
            });
          }
          ctx.prop = mergeRule({}, [this.cacheConfig[ctx.trueType].value, ctx.prop]);
        },
        setOptions(ctx) {
          const opt = ctx.loadPending({
            key: 'options',
            origin: ctx.prop.options,
            def: []
          });
          ctx.prop.options = opt;
          if (ctx.prop.optionsTo && opt) {
            deepSet(ctx.prop, ctx.prop.optionsTo, opt);
          }
        },
        deepSet(ctx) {
          const deep = ctx.rule.deep;
          deep && Object.keys(deep).sort((a, b) => a.length < b.length ? -1 : 1).forEach(str => {
            deepSet(ctx.prop, str, deep[str]);
          });
        },
        parseSide(side) {
          return is.Object(side) ? mergeRule({}, side) : side;
        },
        renderSides(vn, ctx, temp) {
          const prop = ctx[temp ? 'rule' : 'prop'];
          return [this.renderRule(this.parseSide(prop.prefix)), vn, this.renderRule(this.parseSide(prop.suffix))];
        },
        renderId(name, type) {
          const ctxs = this.$handle[type === 'field' ? 'fieldCtx' : 'nameCtx'][name];
          return ctxs ? ctxs.map(ctx => this.renderCtx(ctx, ctx.parent)) : undefined;
        },
        renderCtx(ctx, parent) {
          try {
            if (ctx.type === 'hidden') return;
            const rule = ctx.rule;
            if (!this.cache[ctx.id] || this.cache[ctx.id].slot !== rule.slot) {
              let vn;
              ctx.initProp();
              this.mergeGlobal(ctx);
              ctx.initNone();
              this.$manager.tidyRule(ctx);
              this.deepSet(ctx);
              this.setOptions(ctx);
              this.ctxProp(ctx);
              let prop = ctx.prop;
              prop.preview = !!(hasProperty(prop, 'preview') ? prop.preview : this.options.preview || false);
              prop.props.formCreateInject = this.injectProp(ctx);
              let cacheFlag = prop.cache !== false;
              const preview = prop.preview;
              if (prop.hidden) {
                this.setCache(ctx, undefined, parent);
                return;
              }
              vn = (...slotValue) => {
                const inject = {
                  rule,
                  prop,
                  preview,
                  api: this.$handle.api,
                  model: prop.model || {},
                  slotValue
                };
                if (slotValue.length && rule.slotUpdate) {
                  invoke(() => rule.slotUpdate(inject));
                }
                let children = {};
                const _load = ctx.loadChildrenPending();
                if (ctx.parser.renderChildren) {
                  children = ctx.parser.renderChildren(_load, ctx);
                } else if (ctx.parser.loadChildren !== false) {
                  children = this.renderChildren(_load, ctx);
                }
                const slot = this.getTypeSlot(ctx.type);
                let _vn;
                if (slot) {
                  inject.children = children;
                  _vn = slot(inject);
                } else {
                  _vn = preview ? ctx.parser.preview(children, ctx) : ctx.parser.render(children, ctx);
                }
                _vn = this.renderSides(_vn, ctx);
                if (!(!ctx.input && is.Undef(prop.native)) && prop.native !== true) {
                  _vn = this.$manager.makeWrap(ctx, _vn);
                }
                if (ctx.none) {
                  _vn = this.display(_vn);
                }
                cacheFlag && this.setCache(ctx, () => _vn, parent);
                return _vn;
              };
              this.setCache(ctx, vn, parent);
            }
            return (...args) => {
              const cache = this.getCache(ctx);
              return cache && cache(...args);
            };
          } catch (e) {
            console.error(e);
            return;
          }
        },
        getModelField(ctx) {
          return ctx.rule.modelField || ctx.parser.modelField || this.fc.modelFields[this.vNode.aliasMap[ctx.type]] || this.fc.modelFields[ctx.type] || this.fc.modelFields[ctx.originType] || 'modelValue';
        },
        display(vn) {
          if (Array.isArray(vn)) {
            const data = [];
            vn.forEach(v => {
              if (Array.isArray(v)) return this.display(v);
              if (this.none(v)) data.push(v);
            });
            return data;
          } else {
            return this.none(vn);
          }
        },
        none(vn) {
          if (vn) {
            if (Array.isArray(vn.props.style)) {
              vn.props.style.push({
                display: 'none'
              });
            } else {
              vn.props.style = [vn.props.style, {
                display: 'none'
              }];
            }
            return vn;
          }
        },
        isFragment(ctx) {
          return ctx.type === 'fragment' || ctx.type === 'template';
        },
        injectProp(ctx) {
          const state = this.vm.setupState;
          if (!state.ctxInject[ctx.id]) {
            state.ctxInject[ctx.id] = {
              api: this.$handle.api,
              form: this.fc.create,
              subForm: subForm => {
                this.$handle.addSubForm(ctx, subForm);
              },
              getSubForm: () => {
                return this.$handle.subForm[ctx.id];
              },
              options: [],
              children: [],
              preview: false,
              field: ctx.field,
              rule: ctx.rule,
              input: ctx.input
            };
          }
          const inject = state.ctxInject[ctx.id];
          extend(inject, {
            preview: ctx.prop.preview,
            options: ctx.prop.options,
            children: ctx.loadChildrenPending()
          });
          return inject;
        },
        ctxProp(ctx, custom) {
          const {
            ref,
            key,
            rule
          } = ctx;
          this.$manager.mergeProp(ctx, custom);
          ctx.parser.mergeProp(ctx, custom);
          const props = [{
            ref: ref,
            key: rule.key || `${key}fc`,
            slot: undefined,
            on: {
              vnodeMounted: vn => {
                vn.el.__rule__ = ctx.rule;
                this.onMounted(ctx, vn.el);
              }
            }
          }];
          if (!custom && ctx.input) {
            const field = this.getModelField(ctx);
            const model = {
              callback: value => {
                this.onInput(ctx, value);
              },
              value: this.$handle.getFormData(ctx)
            };
            props.push({
              on: {
                [`update:${field}`]: model.callback
              },
              props: {
                [field]: model.value
              }
            });
            ctx.prop.model = model;
          }
          mergeProps(props, ctx.prop);
          return ctx.prop;
        },
        onMounted(ctx, el) {
          ctx.el = this.vm.refs[ctx.ref] || el;
          ctx.parser.mounted(ctx);
          this.$handle.effect(ctx, 'mounted');
        },
        onInput(ctx, value) {
          this.$handle.onInput(ctx, value);
        },
        renderChildren(children, ctx) {
          if (!is.trueArray(children)) return {};
          const slotBag = makeSlotBag();
          children.map(child => {
            if (!child) return;
            if (is.String(child)) return slotBag.setSlot(null, child);
            if (child.__fc__) {
              return this.renderSlot(slotBag, child.__fc__, ctx);
            }
            if (child.type) {
              vue.nextTick(() => {
                this.$handle.loadChildren(children, ctx);
                this.$handle.refresh();
              });
            }
          });
          return slotBag.getSlots();
        },
        defaultRender(ctx, children) {
          const prop = ctx.prop;
          if (prop.component) return this.vNode.makeComponent(prop.component, prop, children);
          if (this.vNode[ctx.type]) return this.vNode[ctx.type](prop, children);
          if (this.vNode[ctx.originType]) return this.vNode[ctx.originType](prop, children);
          return this.vNode.make(lower(ctx.originType), prop, children);
        },
        renderRule(rule, children, origin) {
          if (!rule) return undefined;
          if (is.String(rule)) return rule;
          let type;
          if (origin) {
            type = rule.type;
          } else {
            type = rule.is;
            if (rule.type) {
              type = toCase(rule.type);
              const alias = this.vNode.aliasMap[type];
              if (alias) type = toCase(alias);
            }
          }
          if (!type) return undefined;
          const slotBag = makeSlotBag();
          if (is.trueArray(rule.children)) {
            rule.children.forEach(v => {
              v && slotBag.setSlot(v === null || v === void 0 ? void 0 : v.slot, () => this.renderRule(v));
            });
          }
          const props = {
            ...rule
          };
          delete props.type;
          delete props.is;
          return this.vNode.make(type, props, slotBag.mergeBag(children).getSlots());
        }
      });
    }

    let id$1 = 1;
    function Render(handle) {
      extend(this, {
        $handle: handle,
        fc: handle.fc,
        vm: handle.vm,
        $manager: handle.$manager,
        vNode: new handle.fc.CreateNode(handle.vm),
        id: id$1++
      });
      funcProxy(this, {
        options() {
          return handle.options;
        },
        sort() {
          return handle.sort;
        }
      });
      this.initCache();
      this.initRender();
    }
    useCache(Render);
    useRender$1(Render);

    function useInject(Handler) {
      extend(Handler.prototype, {
        parseInjectEvent(rule, on) {
          const inject = rule.inject || this.options.injectEvent;
          return this.parseEventLst(rule, on, inject);
        },
        parseEventLst(rule, data, inject, deep) {
          Object.keys(data).forEach(k => {
            const fn = this.parseEvent(rule, data[k], inject, deep);
            if (fn) {
              data[k] = fn;
            }
          });
          return data;
        },
        parseEvent(rule, fn, inject, deep) {
          if (is.Function(fn) && (inject !== false && !is.Undef(inject) || fn.__inject)) {
            return this.inject(rule, fn, inject);
          } else if (!deep && Array.isArray(fn) && fn[0] && (is.String(fn[0]) || is.Function(fn[0]))) {
            return this.parseEventLst(rule, fn, inject, true);
          } else if (is.String(fn)) {
            const val = parseFn(fn);
            if (val && fn !== val) {
              return val.__inject ? this.parseEvent(rule, val, inject, true) : val;
            }
          }
        },
        parseEmit(ctx) {
          let event = {},
            rule = ctx.rule,
            {
              emitPrefix,
              field,
              name,
              inject
            } = rule;
          let emit = rule.emit || [];
          if (is.trueArray(emit)) {
            let emitKey = emitPrefix || field || name;
            if (emitKey) {
              emit.forEach(eventName => {
                if (!eventName) return;
                let eventInject;
                if (is.Object(eventName)) {
                  eventInject = eventName.inject;
                  eventName = eventName.name;
                }
                const fieldKey = toLine(`${emitKey}-${eventName}`);
                const fn = (...arg) => {
                  this.vm.emit(fieldKey, ...arg);
                  this.vm.emit('emit-event', fieldKey, ...arg);
                  this.bus.$emit(fieldKey, ...arg);
                };
                fn.__emit = true;
                if (!eventInject && inject === false) {
                  event[eventName] = fn;
                } else {
                  let _inject = eventInject || inject || this.options.injectEvent;
                  event[eventName] = is.Undef(_inject) ? fn : this.inject(rule, fn, _inject);
                }
              });
            }
          }
          ctx.computed.on = event;
          return event;
        },
        getInjectData(self, inject) {
          const {
            option,
            rule
          } = this.vm;
          return {
            $f: this.api,
            api: this.api,
            rule,
            self: self.__origin__,
            option,
            inject
          };
        },
        inject(self, _fn, inject) {
          if (_fn.__origin) {
            if (this.watching && !this.loading) return _fn;
            _fn = _fn.__origin;
          }
          const h = this;
          const fn = function (...args) {
            const data = h.getInjectData(self, inject);
            data.args = [...args];
            args.unshift(data);
            return _fn.apply(this, args);
          };
          fn.__origin = _fn;
          fn.__json = _fn.__json;
          return fn;
        }
      });
    }

    const EVENT = ['hook:updated', 'hook:mounted'];
    function usePage(Handler) {
      extend(Handler.prototype, {
        usePage() {
          const page = this.options.page;
          if (!page) return;
          let first = 25;
          let limit = getLimit(this.rules);
          if (is.Object(page)) {
            if (page.first) first = parseInt(page.first, 10) || first;
            if (page.limit) limit = parseInt(page.limit, 10) || limit;
          }
          extend(this, {
            first,
            limit,
            pageEnd: this.rules.length <= first
          });
          this.bus.$on('page-end', () => this.vm.emit('page-end', this.api));
          this.pageLoad();
        },
        pageLoad() {
          const pageFn = () => {
            if (this.pageEnd) {
              this.bus.$off(EVENT, pageFn);
              this.bus.$emit('page-end');
            } else {
              this.first += this.limit;
              this.pageEnd = this.rules.length <= this.first;
              this.loadRule();
              this.refresh();
            }
          };
          this.bus.$on(EVENT, pageFn);
        }
      });
    }
    function getLimit(rules) {
      return rules.length < 31 ? 31 : Math.ceil(rules.length / 3);
    }

    function useRender(Handler) {
      extend(Handler.prototype, {
        clearNextTick() {
          this.nextTick && clearTimeout(this.nextTick);
          this.nextTick = null;
        },
        bindNextTick(fn) {
          this.clearNextTick();
          this.nextTick = setTimeout(() => {
            fn();
            this.nextTick = null;
          }, 10);
        },
        render() {
          // console.warn('%c render', 'color:green');
          ++this.loadedId;
          if (this.vm.setupState.unique > 0) return this.$render.render();else {
            this.vm.setupState.unique = 1;
            return [];
          }
        }
      });
    }

    function isNone(ctx) {
      const none = !(is.Undef(ctx.prop.display) || !!ctx.prop.display);
      if (ctx.parent) {
        return ctx.parent.none || none;
      } else {
        return none;
      }
    }
    function bind(ctx) {
      Object.defineProperties(ctx.origin, {
        __fc__: enumerable(vue.markRaw(ctx), true)
      });
    }
    function RuleContext(handle, rule, defaultValue) {
      const id = uniqueId();
      const isInput = !!rule.field;
      extend(this, {
        id,
        ref: id,
        wrapRef: id + 'fi',
        rule,
        origin: rule.__origin__ || rule,
        name: rule.name,
        pending: {},
        none: false,
        watch: [],
        linkOn: [],
        root: [],
        ctrlRule: [],
        parent: null,
        cacheConfig: null,
        prop: {
          ...rule
        },
        computed: {},
        payload: {},
        refRule: {},
        input: isInput,
        el: undefined,
        defaultValue: isInput ? deepCopy(defaultValue) : undefined,
        field: rule.field || undefined
      });
      this.updateType();
      this.updateKey();
      bind(this);
      this.update(handle, true);
    }
    extend(RuleContext.prototype, {
      loadChildrenPending() {
        const children = this.rule.children || [];
        if (Array.isArray(children)) return children;
        return this.loadPending({
          key: 'children',
          origin: children,
          def: [],
          onLoad: data => {
            this.$handle && this.$handle.loadChildren(data, this);
          },
          onUpdate: (value, oldValue) => {
            if (this.$handle) {
              value === oldValue ? this.$handle.loadChildren(value, this) : this.$handle.updateChildren(this, value, oldValue);
            }
          },
          onReload: value => {
            if (this.$handle) {
              this.$handle.updateChildren(this, [], value);
            } else {
              delete this.pending.children;
            }
          }
        });
      },
      loadPending(config) {
        const {
          key,
          origin,
          def,
          onLoad,
          onReload,
          onUpdate
        } = config;
        if (this.pending[key] && this.pending[key].origin === origin) {
          return this.getPending(key, def);
        }
        delete this.pending[key];
        let value = origin;
        if (is.Function(origin)) {
          let source = invoke(() => origin({
            rule: this.rule,
            api: this.$api,
            update: data => {
              const value = data || def;
              const oldValue = this.getPending(key, def);
              this.setPending(key, origin, value);
              onUpdate && onUpdate(value, oldValue);
            },
            reload: () => {
              const oldValue = this.getPending(key, def);
              delete this.pending[key];
              onReload && onReload(oldValue);
              this.$api && this.$api.sync(this.rule);
            }
          }));
          if (source && is.Function(source.then)) {
            source.then(data => {
              const value = data || def;
              this.setPending(key, origin, value);
              onLoad && onLoad(value);
              this.$api && this.$api.sync(this.rule);
            });
            value = def;
            this.setPending(key, origin, value);
          } else {
            value = source || def;
            this.setPending(key, origin, value);
            onLoad && onLoad(value);
          }
        }
        return value;
      },
      getPending(key, def) {
        return this.pending[key] && this.pending[key].value || def;
      },
      setPending(key, origin, value) {
        this.pending[key] = {
          origin,
          value: vue.reactive(value)
        };
      },
      effectData(name) {
        if (!this.payload[name]) {
          this.payload[name] = {};
        }
        return this.payload[name];
      },
      clearEffectData(name) {
        if (name === undefined) {
          this.payload = {};
        } else {
          delete this.payload[name];
        }
      },
      updateKey(flag) {
        this.key = uniqueId();
        flag && this.parent && this.parent.updateKey(flag);
      },
      updateType() {
        this.originType = this.rule.type;
        this.type = toCase(this.rule.type);
      },
      setParser(parser) {
        this.parser = parser;
        parser.init(this);
      },
      initProp() {
        const rule = {
          ...this.rule
        };
        delete rule.children;
        this.prop = mergeProps([rule, ...Object.keys(this.payload).map(k => this.payload[k]), this.computed]);
      },
      initNone() {
        this.none = isNone(this);
      },
      check(handle) {
        return this.vm === handle.vm;
      },
      unwatch() {
        this.watch.forEach(un => un());
        this.watch = [];
        this.refRule = {};
      },
      unlink() {
        this.linkOn.forEach(un => un());
        this.linkOn = [];
      },
      link() {
        this.unlink();
        this.$handle.appendLink(this);
      },
      watchTo() {
        this.$handle.watchCtx(this);
      },
      delete() {
        const undef = void 0;
        this.unwatch();
        this.unlink();
        this.rmCtrl();
        extend(this, {
          deleted: true,
          prop: {
            ...this.rule
          },
          computed: {},
          el: undef,
          $handle: undef,
          $render: undef,
          $api: undef,
          vm: undef,
          vNode: undef,
          parent: null,
          cacheConfig: null,
          none: false
        });
      },
      rmCtrl() {
        this.ctrlRule.forEach(ctrl => ctrl.__fc__ && ctrl.__fc__.rm());
        this.ctrlRule = [];
      },
      rm() {
        const _rm = () => {
          let index = this.root.indexOf(this.origin);
          if (index > -1) {
            this.root.splice(index, 1);
            this.$handle && this.$handle.refresh();
          }
        };
        if (this.deleted) {
          _rm();
          return;
        }
        this.$handle.noWatch(() => {
          this.$handle.deferSyncValue(() => {
            this.rmCtrl();
            _rm();
            this.$handle.rmCtx(this);
            extend(this, {
              root: []
            });
          }, this.input);
        });
      },
      update(handle, init) {
        extend(this, {
          deleted: false,
          $handle: handle,
          $render: handle.$render,
          $api: handle.api,
          vm: handle.vm,
          trueType: handle.getType(this.originType),
          vNode: handle.$render.vNode,
          updated: false
        });
        !init && this.unwatch();
        this.watchTo();
        this.link();
      }
    });

    function useLoader(Handler) {
      extend(Handler.prototype, {
        nextRefresh(fn) {
          const id = this.loadedId;
          vue.nextTick(() => {
            id === this.loadedId && (fn ? fn() : this.refresh());
          });
        },
        parseRule(_rule) {
          const rule = getRule(_rule);
          Object.defineProperties(rule, {
            __origin__: enumerable(_rule, true)
          });
          fullRule(rule);
          this.appendValue(rule);
          [rule, rule['prefix'], rule['suffix']].forEach(item => {
            if (!item) {
              return;
            }
            this.loadFn(item, rule);
          });
          this.loadCtrl(rule);
          if (rule.update) {
            rule.update = parseFn(rule.update);
          }
          return rule;
        },
        loadFn(item, rule) {
          ['on', 'props', 'deep'].forEach(k => {
            item[k] && this.parseInjectEvent(rule, item[k]);
          });
        },
        loadCtrl(rule) {
          rule.control && rule.control.forEach(ctrl => {
            if (ctrl.handle) {
              ctrl.handle = parseFn(ctrl.handle);
            }
          });
        },
        syncProp(ctx) {
          const rule = ctx.rule;
          is.trueArray(rule.sync) && mergeProps([{
            on: rule.sync.reduce((pre, prop) => {
              pre[`update:${prop}`] = val => {
                rule.props[prop] = val;
                this.vm.emit('sync', prop, val, rule, this.fapi);
              };
              return pre;
            }, {})
          }], ctx.computed);
        },
        loadRule() {
          // console.warn('%c load', 'color:blue');
          this.cycleLoad = false;
          this.loading = true;
          if (this.pageEnd) {
            this.bus.$emit('load-start');
          }
          this.deferSyncValue(() => {
            this._loadRule(this.rules);
            this.loading = false;
            if (this.cycleLoad && this.pageEnd) {
              return this.loadRule();
            }
            this.syncForm();
            if (this.pageEnd) {
              this.bus.$emit('load-end');
            }
            this.vm.setupState.renderRule();
          });
        },
        loadChildren(children, parent) {
          this.cycleLoad = false;
          this.loading = true;
          this.bus.$emit('load-start');
          this._loadRule(children, parent);
          this.loading = false;
          if (this.cycleLoad) {
            return this.loadRule();
          } else {
            this.syncForm();
            this.bus.$emit('load-end');
          }
          this.$render.clearCache(parent);
        },
        _loadRule(rules, parent) {
          const preIndex = i => {
            let pre = rules[i - 1];
            if (!pre || !pre.__fc__) {
              return i > 0 ? preIndex(i - 1) : -1;
            }
            let index = this.sort.indexOf(pre.__fc__.id);
            return index > -1 ? index : preIndex(i - 1);
          };
          const loadChildren = (children, parent) => {
            if (is.trueArray(children)) {
              this._loadRule(children, parent);
            }
          };
          rules.map((_rule, index) => {
            if (parent && (is.String(_rule) || is.Undef(_rule))) return;
            if (!this.pageEnd && !parent && index >= this.first) return;
            if (_rule.__fc__ && _rule.__fc__.root === rules && this.ctxs[_rule.__fc__.id]) {
              loadChildren(_rule.__fc__.loadChildrenPending(), _rule.__fc__);
              return _rule.__fc__;
            }
            let rule = getRule(_rule);
            const isRepeat = () => {
              return !!(rule.field && this.fieldCtx[rule.field] && this.fieldCtx[rule.field][0] !== _rule.__fc__);
            };
            this.ruleEffect(rule, 'init', {
              repeat: isRepeat()
            });
            if (isRepeat()) {
              this.vm.emit('repeat-field', _rule, this.api);
            }
            let ctx;
            let isCopy = false;
            let isInit = !!_rule.__fc__;
            let defaultValue = rule.value;
            if (isInit) {
              ctx = _rule.__fc__;
              defaultValue = ctx.defaultValue;
              const check = !ctx.check(this);
              if (ctx.deleted) {
                if (check) {
                  if (isCtrl(ctx)) {
                    return;
                  }
                  ctx.update(this);
                }
              } else {
                if (check) {
                  if (isCtrl(ctx)) {
                    return;
                  }
                  rules[index] = _rule = _rule._clone ? _rule._clone() : copyRule(_rule);
                  ctx = null;
                  isCopy = true;
                }
              }
            }
            if (!ctx) {
              const rule = this.parseRule(_rule);
              ctx = new RuleContext(this, rule, isInit ? defaultValue : rule.value);
              this.bindParser(ctx);
            } else {
              if (ctx.originType !== ctx.rule.type) {
                ctx.updateType();
                this.bindParser(ctx);
              }
              this.appendValue(ctx.rule);
            }
            this.parseEmit(ctx);
            this.syncProp(ctx);
            ctx.parent = parent || null;
            ctx.root = rules;
            this.setCtx(ctx);
            !isCopy && !isInit && this.effect(ctx, 'load');
            const _load = ctx.loadChildrenPending();
            ctx.parser.loadChildren === false || loadChildren(_load, ctx);
            if (!parent) {
              const _preIndex = preIndex(index);
              if (_preIndex > -1 || !index) {
                this.sort.splice(_preIndex + 1, 0, ctx.id);
              } else {
                this.sort.push(ctx.id);
              }
            }
            const r = ctx.rule;
            if (!ctx.updated) {
              ctx.updated = true;
              if (is.Function(r.update)) {
                this.bus.$once('load-end', () => {
                  this.refreshUpdate(ctx, r.value);
                });
              }
              this.effect(ctx, 'loaded');
            }

            // if (ctx.input)
            //     Object.defineProperty(r, 'value', this.valueHandle(ctx));
            if (this.refreshControl(ctx)) this.cycleLoad = true;
            return ctx;
          });
        },
        refreshControl(ctx) {
          return ctx.input && ctx.rule.control && this.useCtrl(ctx);
        },
        useCtrl(ctx) {
          const controls = getCtrl(ctx),
            validate = [],
            api = this.api;
          if (!controls.length) return false;
          for (let i = 0; i < controls.length; i++) {
            const control = controls[i],
              handleFn = control.handle || (val => val === control.value);
            if (!is.trueArray(control.rule)) continue;
            const data = {
              ...control,
              valid: invoke(() => handleFn(ctx.rule.value, api)),
              ctrl: findCtrl(ctx, control.rule),
              isHidden: is.String(control.rule[0])
            };
            if (data.valid && data.ctrl || !data.valid && !data.ctrl && !data.isHidden) continue;
            validate.push(data);
          }
          if (!validate.length) return false;
          const hideLst = [];
          let flag = false;
          this.deferSyncValue(() => {
            validate.reverse().forEach(({
              isHidden,
              valid,
              rule,
              prepend,
              append,
              child,
              ctrl
            }) => {
              if (isHidden) {
                valid ? ctx.ctrlRule.push({
                  __ctrl: true,
                  children: rule,
                  valid
                }) : ctx.ctrlRule.splice(ctx.ctrlRule.indexOf(ctrl), 1);
                hideLst[valid ? 'push' : 'unshift'](() => {
                  this.api.hidden(!valid, rule);
                });
                return;
              }
              if (valid) {
                flag = true;
                const ruleCon = {
                  type: 'fragment',
                  native: true,
                  __ctrl: true,
                  children: rule
                };
                ctx.ctrlRule.push(ruleCon);
                this.bus.$once('load-start', () => {
                  // this.cycleLoad = true;
                  if (prepend) {
                    api.prepend(ruleCon, prepend, child);
                  } else if (append || child) {
                    api.append(ruleCon, append || ctx.id, child);
                  } else {
                    ctx.root.splice(ctx.root.indexOf(ctx.origin) + 1, 0, ruleCon);
                  }
                });
              } else {
                ctx.ctrlRule.splice(ctx.ctrlRule.indexOf(ctrl), 1);
                const ctrlCtx = byCtx(ctrl);
                ctrlCtx && ctrlCtx.rm();
              }
            });
          });
          hideLst.length && vue.nextTick(() => {
            hideLst.forEach(v => v());
          });
          this.vm.emit('control', ctx.origin, this.api);
          this.effect(ctx, 'control');
          return flag;
        },
        reloadRule(rules) {
          return this._reloadRule(rules);
        },
        _reloadRule(rules) {
          // console.warn('%c reload', 'color:red');
          if (!rules) rules = this.rules;
          const ctxs = {
            ...this.ctxs
          };
          this.clearNextTick();
          this.initData(rules);
          this.fc.rules = rules;
          this.deferSyncValue(() => {
            this.bus.$once('load-end', () => {
              Object.keys(ctxs).filter(id => this.ctxs[id] === undefined).forEach(id => this.rmCtx(ctxs[id]));
              this.$render.clearCacheAll();
            });
            this.reloading = true;
            this.loadRule();
            this.reloading = false;
            this.refresh();
            this.bus.$emit('reloading', this.api);
          });
          this.bus.$off('next-tick', this.nextReload);
          this.bus.$once('next-tick', this.nextReload);
          this.bus.$emit('update', this.api);
        },
        //todo 组件生成全部通过 alias
        refresh() {
          this.vm.setupState.refresh();
        }
      });
    }
    function fullRule(rule) {
      const def = baseRule();
      Object.keys(def).forEach(k => {
        if (!hasProperty(rule, k)) rule[k] = def[k];
      });
      return rule;
    }
    function getCtrl(ctx) {
      const control = ctx.rule.control || [];
      if (is.Object(control)) return [control];else return control;
    }
    function findCtrl(ctx, rule) {
      for (let i = 0; i < ctx.ctrlRule.length; i++) {
        const ctrl = ctx.ctrlRule[i];
        if (ctrl.children === rule) return ctrl;
      }
    }
    function isCtrl(ctx) {
      return !!ctx.rule.__ctrl;
    }

    function useInput(Handler) {
      extend(Handler.prototype, {
        setValue(ctx, value, formValue, setFlag) {
          if (ctx.deleted) return;
          ctx.rule.value = value;
          this.changeStatus = true;
          this.nextRefresh();
          this.$render.clearCache(ctx);
          this.setFormData(ctx, formValue);
          this.syncValue();
          this.valueChange(ctx, value);
          this.vm.emit('change', ctx.field, value, ctx.origin, this.api, setFlag || false);
          this.effect(ctx, 'value');
        },
        onInput(ctx, value) {
          let val;
          if (ctx.input && (this.isQuote(ctx, val = ctx.parser.toValue(value, ctx)) || this.isChange(ctx, value))) {
            this.setValue(ctx, val, value);
          }
        },
        setFormData(ctx, value) {
          $set(this.formData, ctx.id, value);
        },
        getFormData(ctx) {
          return this.formData[ctx.id];
        },
        syncForm() {
          const data = vue.reactive({});
          this.fields().reduce((initial, field) => {
            const ctx = this.getCtx(field);
            initial[field] = vue.toRef(ctx.rule, 'value');
            return initial;
          }, data);
          this.form = data;
          this.syncValue();
        },
        appendValue(rule) {
          if (!rule.field || !hasProperty(this.appendData, rule.field)) return;
          rule.value = this.appendData[rule.field];
          delete this.appendData[rule.field];
        },
        addSubForm(ctx, subForm) {
          this.subForm[ctx.id] = subForm;
        },
        deferSyncValue(fn, sync) {
          if (!this.deferSyncFn) {
            this.deferSyncFn = fn;
          }
          if (!this.deferSyncFn.sync) {
            this.deferSyncFn.sync = sync;
          }
          invoke(fn);
          if (this.deferSyncFn === fn) {
            this.deferSyncFn = null;
            if (fn.sync) {
              this.syncValue();
            }
          }
        },
        syncValue() {
          if (this.deferSyncFn) {
            return this.deferSyncFn.sync = true;
          }
          this.vm.setupState.updateValue({
            ...this.form
          });
        },
        isChange(ctx, value) {
          return JSON.stringify(this.getFormData(ctx), strFn) !== JSON.stringify(value, strFn);
        },
        isQuote(ctx, value) {
          return (is.Object(value) || Array.isArray(value)) && value === ctx.rule.value;
        },
        refreshUpdate(ctx, val) {
          if (is.Function(ctx.rule.update)) {
            const state = invoke(() => ctx.rule.update(val, ctx.origin, this.api));
            if (state === undefined) return;
            ctx.rule.hidden = state === true;
          }
        },
        valueChange(ctx, val) {
          this.refreshRule(ctx, val);
          this.bus.$emit('change-' + ctx.field, val);
        },
        refreshRule(ctx, val) {
          if (this.refreshControl(ctx)) {
            this.$render.clearCacheAll();
            this.loadRule();
            this.bus.$emit('update', this.api);
            this.refresh();
          }
          this.refreshUpdate(ctx, val);
        },
        appendLink(ctx) {
          const link = ctx.rule.link;
          is.trueArray(link) && link.forEach(field => {
            const fn = () => this.refreshRule(ctx, ctx.rule.value);
            this.bus.$on('change-' + field, fn);
            ctx.linkOn.push(() => this.bus.$off('change-' + field, fn));
          });
        },
        fields() {
          return Object.keys(this.fieldCtx);
        }
      });
    }
    function strFn(key, val) {
      return typeof val === 'function' ? '' + val : val;
    }

    const BaseParser = {
      init(ctx) {},
      toFormValue(value, ctx) {
        return value;
      },
      toValue(formValue, ctx) {
        return formValue;
      },
      mounted(ctx) {},
      render(children, ctx) {
        return ctx.$render.defaultRender(ctx, children);
      },
      preview(children, ctx) {
        return this.render(children, ctx);
      },
      mergeProp(ctx) {}
    };

    const _ = {
      sum(arr) {
        if (Array.isArray(arr)) {
          let val = 0;
          arr.map(v => val += v || 0);
          return val;
        }
      },
      column(arr, field) {
        if (Array.isArray(arr)) {
          return arr.map(v => v[field]);
        }
        return [];
      },
      get(obj, field, def) {
        const lst = field.split('.');
        let val = obj;
        for (let i = 0; i < lst.length; i++) {
          if (hasProperty(val, lst[i])) {
            val = val[lst[i]];
          } else {
            return def === undefined ? 0 : def;
          }
        }
        return val;
      }
    };
    const noneKey = ['field', 'value', 'vm', 'template', 'name', 'config', 'control', 'inject', 'sync', 'payload', 'optionsTo', 'update', 'slotUpdate', 'computed', 'component', 'cache'];
    function useContext(Handler) {
      extend(Handler.prototype, {
        getCtx(id) {
          return this.getFieldCtx(id) || this.getNameCtx(id)[0] || this.ctxs[id];
        },
        getCtxs(id) {
          return this.fieldCtx[id] || this.nameCtx[id] || (this.ctxs[id] ? [this.ctxs[id]] : []);
        },
        setIdCtx(ctx, key, type) {
          const field = `${type}Ctx`;
          if (!this[field][key]) {
            this[field][key] = [ctx];
          } else {
            this[field][key].push(ctx);
          }
        },
        rmIdCtx(ctx, key, type) {
          const field = `${type}Ctx`;
          const lst = this[field][key];
          if (!lst) return false;
          const flag = lst.splice(lst.indexOf(ctx) >>> 0, 1).length > 0;
          if (!lst.length) {
            delete this[field][key];
          }
          return flag;
        },
        getFieldCtx(field) {
          return (this.fieldCtx[field] || [])[0];
        },
        getNameCtx(name) {
          return this.nameCtx[name] || [];
        },
        setCtx(ctx) {
          let {
            id,
            field,
            name,
            rule
          } = ctx;
          this.ctxs[id] = ctx;
          name && this.setIdCtx(ctx, name, 'name');
          if (!ctx.input) return;
          this.setIdCtx(ctx, field, 'field');
          this.setFormData(ctx, ctx.parser.toFormValue(rule.value, ctx));
          if (this.isMounted && !this.reloading) {
            this.vm.emit('change', ctx.field, rule.value, ctx.origin, this.api);
          }
        },
        getParser(ctx) {
          const list = this.fc.parsers;
          return list[ctx.originType] || list[toCase(ctx.type)] || list[ctx.trueType] || BaseParser;
        },
        bindParser(ctx) {
          ctx.setParser(this.getParser(ctx));
        },
        getType(alias) {
          const map = this.fc.CreateNode.aliasMap;
          const type = map[alias] || map[toCase(alias)] || alias;
          return toCase(type);
        },
        noWatch(fn) {
          if (!this.noWatchFn) {
            this.noWatchFn = fn;
          }
          invoke(fn);
          if (this.noWatchFn === fn) {
            this.noWatchFn = null;
          }
        },
        watchCtx(ctx) {
          const all = attrs();
          all.filter(k => k[0] !== '_' && k[0] !== '$' && noneKey.indexOf(k) === -1).forEach(key => {
            const ref = vue.toRef(ctx.rule, key);
            const flag = key === 'children';
            ctx.refRule[key] = ref;
            ctx.watch.push(vue.watch(flag ? () => is.Function(ref.value) ? ref.value : [...(ref.value || [])] : () => ref.value, (_, o) => {
              let n = ref.value;
              if (this.isBreakWatch()) return;
              if (flag && ctx.parser.loadChildren === false) {
                this.$render.clearCache(ctx);
                this.nextRefresh();
                return;
              }
              this.watching = true;
              if (key === 'link') {
                ctx.link();
                return;
              } else if (['props', 'on', 'deep'].indexOf(key) > -1) {
                this.parseInjectEvent(ctx.rule, n || {});
                if (key === 'props' && ctx.input) {
                  this.setFormData(ctx, ctx.parser.toFormValue(ctx.rule.value, ctx));
                }
              } else if (key === 'emit') this.parseEmit(ctx);else if (['prefix', 'suffix'].indexOf(key) > -1) n && this.loadFn(n, ctx.rule);else if (key === 'type') {
                ctx.updateType();
                this.bindParser(ctx);
              } else if (flag) {
                if (is.Function(o)) {
                  o = ctx.getPending('children', []);
                }
                if (is.Function(n)) {
                  n = ctx.loadChildrenPending();
                }
                this.updateChildren(ctx, n, o);
              }
              this.$render.clearCache(ctx);
              this.refresh();
              this.watching = false;
            }, {
              deep: !flag,
              sync: flag
            }));
          });
          if (ctx.input) {
            const val = vue.toRef(ctx.rule, 'value');
            ctx.watch.push(vue.watch(() => val.value, () => {
              let formValue = ctx.parser.toFormValue(val.value, ctx);
              if (this.isChange(ctx, formValue)) {
                this.setValue(ctx, val.value, formValue, true);
              }
            }));
            this.bus.$once('load-end', () => {
              const computedRef = vue.toRef(ctx.rule, 'computed');
              ctx.watch.push(vue.watch(() => {
                const computed = computedRef.value;
                if (!computed) return undefined;
                let fn;
                if (is.Function(computed)) {
                  fn = () => computed(this.api.form, this.api);
                } else {
                  fn = () => new Function('_', `with(this){ return ${computed} }`).call(this.api.form, _);
                }
                return invoke(fn, undefined);
              }, n => {
                val.value = n;
              }, {
                immediate: !!computedRef.value
              }));
            });
          }
          this.watchEffect(ctx);
        },
        updateChildren(ctx, n, o) {
          this.deferSyncValue(() => {
            o && o.forEach(child => {
              if ((n || []).indexOf(child) === -1 && child && !is.String(child) && child.__fc__ && child.__fc__.parent === ctx) {
                this.rmCtx(child.__fc__);
              }
            });
            if (is.trueArray(n)) {
              this.loadChildren(n, ctx);
              this.bus.$emit('update', this.api);
            }
          });
        },
        rmSub(sub) {
          is.trueArray(sub) && sub.forEach(r => {
            r && r.__fc__ && this.rmCtx(r.__fc__);
          });
        },
        rmCtx(ctx) {
          if (ctx.deleted) return;
          const {
            id,
            field,
            input,
            name
          } = ctx;
          $del(this.ctxs, id);
          $del(this.formData, id);
          $del(this.subForm, id);
          $del(this.vm.setupState.ctxInject, id);
          input && this.rmIdCtx(ctx, field, 'field');
          name && this.rmIdCtx(ctx, name, 'name');
          if (input && !hasProperty(this.fieldCtx, field)) {
            $del(this.form, field);
          }
          this.deferSyncValue(() => {
            if (!this.reloading) {
              if (ctx.parser.loadChildren !== false) {
                const children = ctx.getPending('children', ctx.rule.children);
                if (is.trueArray(children)) {
                  children.forEach(h => h.__fc__ && this.rmCtx(h.__fc__));
                }
              }
              if (ctx.root === this.rules) {
                this.vm.setupState.renderRule();
              }
            }
          }, input);
          const index = this.sort.indexOf(id);
          if (index > -1) {
            this.sort.splice(index, 1);
          }
          this.$render.clearCache(ctx);
          ctx.delete();
          this.effect(ctx, 'deleted');
          input && !this.fieldCtx[field] && this.vm.emit('remove-field', field, ctx.rule, this.api);
          ctx.rule.__ctrl || this.vm.emit('remove-rule', ctx.rule, this.api);
          return ctx;
        }
      });
    }

    function useLifecycle(Handler) {
      extend(Handler.prototype, {
        mounted() {
          const _mounted = () => {
            this.isMounted = true;
            this.lifecycle('mounted');
          };
          if (this.pageEnd) {
            _mounted();
          } else {
            this.bus.$once('page-end', _mounted);
          }
        },
        lifecycle(name) {
          const fn = this.options[name];
          is.Function(fn) && invoke(() => fn(this.api));
          this.vm.emit(name, this.api);
        }
      });
    }

    function useEffect(Handler) {
      extend(Handler.prototype, {
        useProvider() {
          const ps = this.fc.providers;
          Object.keys(ps).forEach(k => {
            let prop = ps[k];
            if (is.Function(prop)) {
              prop = prop(this.fc);
            }
            prop._c = getComponent(prop);
            this.onEffect(prop);
            this.providers[k] = prop;
          });
        },
        onEffect(provider) {
          const used = [];
          (provider._c || ['*']).forEach(name => {
            const type = name === '*' ? '*' : this.getType(name);
            if (used.indexOf(type) > -1) return;
            used.push(type);
            this.bus.$on(`p:${provider.name}:${type}:${provider.input ? 1 : 0}`, (event, args) => {
              provider[event] && provider[event](...args);
            });
          });
          provider._used = used;
        },
        watchEffect(ctx) {
          let effect = {};
          Object.keys(ctx.rule.effect || {}).forEach(k => {
            effect[k] = () => ctx.rule.effect[k];
          });
          Object.keys(ctx.rule).forEach(k => {
            if (k[0] === '$') {
              effect[k.substr(1)] = () => ctx.rule[k];
            }
          });
          Object.keys(effect).forEach(k => {
            ctx.watch.push(vue.watch(effect[k], n => {
              this.effect(ctx, 'watch', {
                [k]: n
              });
            }, {
              deep: true
            }));
          });
        },
        ruleEffect(rule, event, append) {
          this.emitEffect({
            rule,
            input: !!rule.field,
            type: this.getType(rule.type)
          }, event, append);
        },
        effect(ctx, event, custom) {
          this.emitEffect({
            rule: ctx.rule,
            input: ctx.input,
            type: ctx.trueType,
            ctx,
            custom
          }, event);
        },
        getEffect(rule, name) {
          if (hasProperty(rule, '$' + name)) {
            return rule['$' + name];
          }
          if (hasProperty(rule, 'effect') && hasProperty(rule.effect, name)) return rule.effect[name];
          return undefined;
        },
        emitEffect({
          ctx,
          rule,
          input,
          type,
          custom
        }, event, append) {
          if (!type || ['fcFragment', 'fragment'].indexOf(type) > -1) return;
          const effect = custom ? custom : Object.keys(rule).reduce((i, k) => {
            if (k[0] === '$') {
              i[k.substr(1)] = rule[k];
            }
            return i;
          }, {
            ...(rule.effect || {})
          });
          Object.keys(effect).forEach(attr => {
            const p = this.providers[attr];
            if (!p || p.input && !input) return;
            let _type;
            if (!p._c) {
              _type = '*';
            } else if (p._used.indexOf(type) > -1) {
              _type = type;
            } else {
              return;
            }
            const data = {
              value: effect[attr],
              getValue: () => this.getEffect(rule, attr),
              ...(append || {})
            };
            if (ctx) {
              data.getProp = () => ctx.effectData(attr);
              data.clearProp = () => ctx.clearEffectData(attr);
              data.mergeProp = prop => mergeProps([prop], data.getProp());
            }
            this.bus.$emit(`p:${attr}:${_type}:${p.input ? 1 : 0}`, event, [data, rule, this.api]);
          });
        }
      });
    }
    function unique(arr) {
      return arr.filter(function (item, index, arr) {
        return arr.indexOf(item, 0) === index;
      });
    }
    function getComponent(p) {
      const c = p.components;
      if (Array.isArray(c)) return unique(c.filter(v => v !== '*'));else if (is.String(c)) return [c];else return false;
    }

    function Handler(fc) {
      funcProxy(this, {
        options() {
          return fc.options.value || {};
        },
        bus() {
          return fc.bus;
        }
      });
      extend(this, {
        fc,
        vm: fc.vm,
        watching: false,
        loading: false,
        reloading: false,
        noWatchFn: null,
        deferSyncFn: null,
        isMounted: false,
        formData: vue.reactive({}),
        subForm: {},
        form: vue.reactive({}),
        appendData: {},
        providers: {},
        cycleLoad: null,
        loadedId: 1,
        nextTick: null,
        changeStatus: false,
        pageEnd: true,
        nextReload: () => {
          this.lifecycle('reload');
        }
      });
      this.initData(fc.rules);
      this.$manager = new fc.manager(this);
      this.$render = new Render(this);
      this.api = fc.extendApi(Api(this), this);
    }
    extend(Handler.prototype, {
      initData(rules) {
        extend(this, {
          ctxs: {},
          fieldCtx: {},
          nameCtx: {},
          sort: [],
          rules
        });
      },
      init() {
        this.appendData = {
          ...(this.options.formData || {}),
          ...(this.fc.vm.props.modelValue || {}),
          ...this.appendData
        };
        this.useProvider();
        this.usePage();
        this.loadRule();
        this.$manager.__init();
      },
      isBreakWatch() {
        return this.loading || this.noWatchFn || this.reloading;
      }
    });
    useInject(Handler);
    usePage(Handler);
    useRender(Handler);
    useLoader(Handler);
    useInput(Handler);
    useContext(Handler);
    useLifecycle(Handler);
    useEffect(Handler);

    // https://github.com/ElemeFE/element/blob/dev/packages/upload/src/ajax.js

    function getError(action, option, xhr) {
      const msg = `fail to ${action} ${xhr.status}'`;
      const err = new Error(msg);
      err.status = xhr.status;
      err.url = action;
      return err;
    }
    function getBody(xhr) {
      const text = xhr.responseText || xhr.response;
      if (!text) {
        return text;
      }
      try {
        return JSON.parse(text);
      } catch (e) {
        return text;
      }
    }
    function fetch$1(option) {
      if (typeof XMLHttpRequest === 'undefined') {
        return;
      }
      const xhr = new XMLHttpRequest();
      const action = option.action;
      xhr.onerror = function error(e) {
        option.onError(e);
      };
      xhr.onload = function onload() {
        if (xhr.status < 200 || xhr.status >= 300) {
          return option.onError(getError(action, option, xhr), getBody(xhr));
        }
        option.onSuccess(getBody(xhr));
      };
      xhr.open(option.method || 'get', action, true);
      let formData;
      if (option.data) {
        if ((option.dataType || '').toLowerCase() !== 'json') {
          formData = new FormData();
          Object.keys(option.data).map(key => {
            formData.append(key, option.data[key]);
          });
        } else {
          formData = JSON.stringify(option.data);
          xhr.setRequestHeader('content-type', 'application/json');
        }
      }
      if (option.withCredentials && 'withCredentials' in xhr) {
        xhr.withCredentials = true;
      }
      const headers = option.headers || {};
      Object.keys(headers).forEach(item => {
        if (headers[item] !== null) {
          xhr.setRequestHeader(item, headers[item]);
        }
      });
      xhr.send(formData);
    }

    const NAME = 'fcFragment';
    var fragment = vue.defineComponent({
      name: NAME,
      inheritAttrs: false,
      props: ['vnode'],
      render() {
        return this.vnode;
      }
    });

    function tidyDirectives(directives) {
      return Object.keys(directives).map(n => {
        const data = directives[n];
        const directive = vue.resolveDirective(n);
        if (!directive) return;
        return [directive, data.value, data.arg, data.modifiers];
      }).filter(v => !!v);
    }
    function makeDirective(data, vn) {
      let directives = data.directives;
      if (!directives) return vn;
      if (!Array.isArray(directives)) {
        directives = [directives];
      }
      return vue.withDirectives(vn, directives.reduce((lst, v) => {
        return lst.concat(tidyDirectives(v));
      }, []));
    }
    function CreateNodeFactory() {
      const aliasMap = {};
      function CreateNode() {}
      extend(CreateNode.prototype, {
        make(tag, data, children) {
          return makeDirective(data, this.h(tag, toProps(data), children));
        },
        makeComponent(type, data, children) {
          try {
            return makeDirective(data, vue.createVNode(type, toProps(data), children));
          } catch (e) {
            console.error(e);
            return vue.createVNode('');
          }
        },
        h(tag, data, children) {
          const isNativeTag = vue.getCurrentInstance().appContext.config.isNativeTag(tag);
          if (isNativeTag) {
            delete data.formCreateInject;
          }
          try {
            return vue.createVNode(isNativeTag ? tag : vue.resolveComponent(tag), data, children);
          } catch (e) {
            console.error(e);
            return vue.createVNode('');
          }
        },
        aliasMap
      });
      extend(CreateNode, {
        aliasMap,
        alias(alias, name) {
          aliasMap[alias] = name;
        },
        use(nodes) {
          Object.keys(nodes).forEach(k => {
            const line = toLine(k);
            const lower = toString(k).toLocaleLowerCase();
            const v = nodes[k];
            [k, line, lower].forEach(n => {
              CreateNode.alias(k, v);
              CreateNode.prototype[n] = function (data, children) {
                return this.make(v, data, children);
              };
            });
          });
        }
      });
      return CreateNode;
    }

    function createManager(proto) {
      class CustomManager extends Manager {}
      Object.assign(CustomManager.prototype, proto);
      return CustomManager;
    }
    function Manager(handler) {
      extend(this, {
        $handle: handler,
        vm: handler.vm,
        options: {},
        ref: 'fcForm',
        mergeOptionsRule: {
          normal: ['form', 'row', 'info', 'submitBtn', 'resetBtn']
        }
      });
      this.updateKey();
      this.init();
    }
    extend(Manager.prototype, {
      __init() {
        this.$render = this.$handle.$render;
        this.$r = (...args) => this.$render.renderRule(...args);
      },
      updateKey() {
        this.key = uniqueId();
      },
      //TODO interface
      init() {},
      update() {},
      beforeRender() {},
      form() {
        return this.vm.refs[this.ref];
      },
      mergeOptions(args, opt) {
        return mergeProps(args.map(v => this.tidyOptions(v)), opt, this.mergeOptionsRule);
      },
      updateOptions(options) {
        this.options = this.mergeOptions([options], this.getDefaultOptions());
        this.update();
      },
      tidyOptions(options) {
        return options;
      },
      tidyRule(ctx) {},
      mergeProp(ctx) {},
      getDefaultOptions() {
        return {};
      },
      render(children) {}
    });

    const fetch = function (fc) {
      function parseOpt(option) {
        if (is.String(option)) {
          option = {
            action: option,
            to: 'options'
          };
        }
        return option;
      }
      function run(inject, rule, api) {
        let option = inject.value;
        if (is.Function(option)) {
          option = option(rule, api);
        }
        option = parseOpt(option);
        if (!option || !option.action) {
          return false;
        }
        if (!option.to) {
          option.to = 'options';
        }
        const onError = option.onError;
        const check = () => {
          if (!inject.getValue()) {
            inject.clearProp();
            api.sync(rule);
            return true;
          }
        };
        const set = val => {
          if (val === undefined) {
            inject.clearProp();
            api.sync(rule);
          } else {
            deepSet(inject.getProp(), option.to, val);
          }
        };
        invoke(() => fc.create.fetch({
          ...option,
          onSuccess(body) {
            if (check()) return;
            let fn = v => v.data;
            if (is.Function(option.parse)) {
              fn = option.parse;
            }
            set(fn(body, rule, api));
            api.sync(rule);
          },
          onError(e) {
            set(undefined);
            if (check()) return;
            (onError || (e => err(e.message || 'fetch fail ' + option.action)))(e, rule, api);
          }
        }, {
          inject,
          rule,
          api
        }));
        return true;
      }
      return {
        name: 'fetch',
        loaded(...args) {
          run(...args);
        },
        watch(inject, rule, api) {
          if (!run(inject, rule, api)) {
            inject.clearProp();
            api.sync(rule);
          }
        }
      };
    };
    var $provider = {
      fetch
    };

    const name$5 = 'html';
    var html = {
      name: name$5,
      loadChildren: false,
      render(children, ctx) {
        ctx.prop.props.innerHTML = children.default();
        return ctx.vNode.make(ctx.prop.props.tag || 'div', ctx.prop);
      },
      renderChildren(children) {
        return {
          default: () => children.filter(v => is.String(v)).join('')
        };
      }
    };

    function parseProp(name, id) {
      let prop;
      if (arguments.length === 2) {
        prop = arguments[1];
        id = prop[name];
      } else {
        prop = arguments[2];
      }
      return {
        id,
        prop
      };
    }
    function nameProp() {
      return parseProp('name', ...arguments);
    }
    function exportAttrs(attrs) {
      const key = attrs.key || [];
      const array = attrs.array || [];
      const normal = attrs.normal || [];
      keyAttrs.push(...key);
      arrayAttrs.push(...array);
      normalAttrs.push(...normal);
      appendProto([...key, ...array, ...normal]);
    }
    let id = 1;
    const instance = {};

    //todo 表单嵌套
    function FormCreateFactory(config) {
      const components = {
        [fragment.name]: fragment
      };
      const parsers = {};
      const directives = {};
      const modelFields = {};
      const useApps = [];
      const providers = {
        ...$provider
      };
      const maker = makerFactory();
      let globalConfig = {
        global: {}
      };
      const data = {};
      const CreateNode = CreateNodeFactory();
      exportAttrs(config.attrs || {});
      function getApi(name) {
        const val = instance[name];
        if (Array.isArray(val)) return [...val];
        return val;
      }
      function useApp(fn) {
        useApps.push(fn);
      }
      function directive() {
        const data = nameProp(...arguments);
        if (data.id && data.prop) directives[data.id] = data.prop;
      }
      function register() {
        const data = nameProp(...arguments);
        if (data.id && data.prop) providers[data.id] = {
          ...data.prop,
          name: data.id
        };
      }
      function componentAlias(alias) {
        CreateNode.use(alias);
      }
      function parser() {
        const data = nameProp(...arguments);
        if (!data.id || !data.prop) return;
        const name = toCase(data.id);
        const parser = data.prop;
        const base = parser.merge === true ? parsers[name] : undefined;
        parsers[name] = {
          ...(base || BaseParser),
          ...parser
        };
        maker[name] = creatorFactory(name);
        parser.maker && extend(maker, parser.maker);
      }
      function component(id, component) {
        let name;
        if (is.String(id)) {
          name = toCase(id);
          if (component === undefined) {
            return components[name];
          }
        } else {
          name = toCase(id.displayName || id.name);
          component = id;
        }
        if (!name || !component) return;
        components[name] = component;
        if (component.formCreateParser) parser(name, component.formCreateParser);
      }
      function $form() {
        return $FormCreate(FormCreate);
      }
      function createFormApp(rule, option) {
        const Type = $form();
        return vue.createApp({
          data() {
            return vue.reactive({
              rule,
              option
            });
          },
          render() {
            return vue.h(Type, {
              ref: 'fc',
              ...this.$data
            });
          }
        });
      }
      function $vnode() {
        return fragment;
      }

      //todo 检查回调函数作用域
      function use(fn, opt) {
        if (is.Function(fn.install)) fn.install(create, opt);else if (is.Function(fn)) fn(create, opt);
        return this;
      }
      function create(rules, option) {
        let app = createFormApp(rules, option || {});
        useApps.forEach(v => {
          invoke(() => v(create, app));
        });
        const div = document.createElement('div');
        ((option === null || option === void 0 ? void 0 : option.el) || document.body).appendChild(div);
        const vm = app.mount(div);
        return vm.$refs.fc.fapi;
      }
      function factory(inherit) {
        let _config = {
          ...config
        };
        if (inherit) {
          _config.inherit = {
            components,
            parsers,
            directives,
            modelFields,
            providers,
            useApps,
            maker,
            data
          };
        } else {
          delete _config.inherit;
        }
        return FormCreateFactory(_config);
      }
      function setModelField(name, field) {
        modelFields[name] = field;
      }
      function FormCreate(vm) {
        extend(this, {
          id: id++,
          create,
          vm,
          manager: createManager(config.manager),
          parsers,
          providers,
          modelFields,
          rules: vm.props.rule,
          name: vm.props.name,
          inFor: vm.props.inFor,
          prop: {
            components,
            directives
          },
          CreateNode,
          bus: new Mitt(),
          unwatch: null,
          options: vue.ref(vm.props.option || {}),
          extendApi: config.extendApi || (api => api)
        });
        vue.nextTick(() => {
          vue.watch(this.options, () => {
            this.$handle.$manager.updateOptions(this.options.value);
            this.api().refresh();
          }, {
            deep: true
          });
        });
        extend(vm.appContext.components, components);
        extend(vm.appContext.directives, directives);
        this.$handle = new Handler(this);
        if (this.name) {
          if (this.inFor) {
            if (!instance[this.name]) instance[this.name] = [];
            instance[this.name].push(this.api());
          } else {
            instance[this.name] = this.api();
          }
        }
      }
      extend(FormCreate.prototype, {
        init() {
          if (this.isSub()) {
            this.unwatch = vue.watch(() => this.vm.parent.option, () => {
              this.initOptions(this.options.value);
              this.$handle.api.refresh();
            }, {
              deep: true
            });
          }
          this.initOptions(this.options.value);
          this.$handle.init();
        },
        isSub() {
          return this.vm.setupState.parent && this.vm.setupState.extendOption;
        },
        initOptions(options) {
          this.options.value = {
            formData: {},
            submitBtn: {},
            resetBtn: {},
            ...deepCopy(globalConfig)
          };
          if (this.isSub()) {
            this.options.value = this.mergeOptions(this.options.value, this.vm.setupState.parent.setupState.fapi.config || {}, true);
          }
          this.updateOptions(options);
        },
        mergeOptions(target, opt, parent) {
          opt = deepCopy(opt);
          parent && ['page', 'onSubmit', 'mounted', 'reload', 'formData', 'el'].forEach(n => {
            delete opt[n];
          });
          if (opt.global) {
            target.global = mergeGlobal(target.global, opt.global);
            delete opt.global;
          }
          this.$handle.$manager.mergeOptions([opt], target);
          return target;
        },
        updateOptions(options) {
          this.options.value = this.mergeOptions(this.options.value, options);
          this.$handle.$manager.updateOptions(this.options.value);
        },
        api() {
          return this.$handle.api;
        },
        render() {
          return this.$handle.render();
        },
        mounted() {
          this.$handle.mounted();
        },
        unmount() {
          if (this.name) {
            if (this.inFor) {
              const idx = instance[this.name].indexOf(this.api());
              instance[this.name].splice(idx, 1);
            } else {
              delete instance[this.name];
            }
          }
          this.unwatch && this.unwatch();
          this.$handle.reloadRule([]);
        },
        updated() {
          this.$handle.bindNextTick(() => this.bus.$emit('next-tick', this.$handle.api));
        }
      });
      function useAttr(formCreate) {
        extend(formCreate, {
          version: config.version,
          ui: config.ui,
          data,
          maker,
          component,
          directive,
          setModelField,
          register,
          $vnode,
          parser,
          use,
          factory,
          componentAlias,
          copyRule,
          copyRules,
          fetch: fetch$1,
          $form,
          parseFn,
          parseJson,
          toJson,
          useApp,
          getApi
        });
      }
      function useStatic(formCreate) {
        extend(formCreate, {
          create,
          install(app, options) {
            globalConfig = {
              ...globalConfig,
              ...(options || {})
            };
            if (app._installedFormCreate === true) return;
            app._installedFormCreate = true;
            const $formCreate = function (rules, opt = {}) {
              return create(rules, opt);
            };
            useAttr($formCreate);
            app.config.globalProperties.$formCreate = $formCreate;
            app.component('FormCreate', $form());
            useApps.forEach(v => {
              invoke(() => v(formCreate, app));
            });
          }
        });
      }
      useAttr(create);
      useStatic(create);
      CreateNode.use({
        fragment: 'fcFragment'
      });
      config.install && create.use(config);
      useApp((_, app) => {
        app.mixin({
          props: ['formCreateInject']
        });
      });
      parser(html);
      if (config.inherit) {
        const inherit = config.inherit;
        inherit.components && extend(components, inherit.components);
        inherit.parsers && extend(parsers, inherit.parsers);
        inherit.directives && extend(directives, inherit.directives);
        inherit.modelFields && extend(modelFields, inherit.modelFields);
        inherit.providers && extend(providers, inherit.providers);
        inherit.useApps && extend(useApps, inherit.useApps);
        inherit.maker && extend(maker, inherit.maker);
        inherit.data && extend(data, inherit.data);
      }
      return create;
    }

    const FORMAT_TYPE = {
      date: 'YYYY-MM-DD',
      month: 'YYYY-MM',
      week: 'YYYY-wo',
      year: 'YYYY'
    };
    const name$4 = 'datePicker';
    var datePicker = {
      name: name$4,
      maker: function () {
        return ['date', 'month', 'week'].reduce((initial, type) => {
          initial[type] = creatorFactory(name$4, {
            type
          });
          return initial;
        }, {
          dateRange: creatorFactory(name$4, {
            type: 'range'
          }),
          datetimeRange: creatorFactory(name$4, m => m.props({
            type: 'range',
            showTime: true
          }))
        });
      }(),
      modelField: 'value',
      mergeProp(ctx) {
        const props = ctx.prop.props;
        const type = props.type || props.picker;
        if (!props.valueFormat) {
          props.valueFormat = (FORMAT_TYPE[type] || FORMAT_TYPE['date']) + (props.showTime && (!type || type === 'date') ? ' HH:mm:ss' : '');
        }
      },
      render(children, ctx) {
        return ctx.$render.vNode[(ctx.prop.props.range === true ? 'range' : 'date') + 'Picker'](ctx.prop, children);
      }
    };

    const name$3 = 'hidden';
    var hidden = {
      name: name$3,
      maker: {
        [name$3]: (field, value) => creatorFactory(name$3)('', field, value)
      },
      render() {
        return [];
      }
    };

    const name$2 = 'input';
    var input = {
      name: name$2,
      maker: function () {
        return ['password', 'url', 'email', 'text', 'textarea', 'search'].reduce((maker, type) => {
          maker[type] = creatorFactory(name$2, {
            type
          });
          return maker;
        }, {
          idate: creatorFactory(name$2, {
            type: 'date'
          })
        });
      }(),
      modelField: 'value',
      render(children, ctx) {
        let type = ctx.prop.props.type;
        if (['textarea', 'search'].indexOf(type) === -1) type = 'input';
        type = {
          textarea: 'ATextarea',
          search: 'AInputSearch'
        }[type] || 'AInput';
        return ctx.$render.vNode.make(type, ctx.prop, children);
      }
    };

    var timePicker = {
      name: 'timePicker',
      modelField: 'value',
      mergeProp(ctx) {
        const props = ctx.prop.props;
        if (!props.valueFormat) {
          props.valueFormat = 'HH:mm:ss';
        }
      },
      render(children, ctx) {
        return ctx.$render.vNode['time' + (ctx.prop.props.range === true ? 'Range' : '') + 'Picker'](ctx.prop, children);
      }
    };

    var tree = {
      name: 'tree',
      modelField: 'checkedKeys',
      mergeProp(ctx) {
        const props = ctx.prop.props;
        if (!props.fieldNames) props.fieldNames = {
          key: 'id'
        };else if (!props.fieldNames.key) props.fieldNames.key = 'id';
        props.checkedKeys = ctx.rule.value;
        props.checkable = true;
      }
    };

    var row = {
      name: 'FcRow',
      render(_, ctx) {
        return ctx.vNode.col({
          props: {
            span: 24
          }
        }, {
          default: () => [ctx.vNode.row(ctx.prop, _)]
        });
      }
    };

    const name$1 = 'rangePicker';
    var rangePicker = {
      ...datePicker,
      name: name$1,
      maker: {},
      render(children, ctx) {
        return ctx.$render.vNode['rangePicker'](ctx.prop, children);
      }
    };

    const name = 'timeRangePicker';
    var timeRangePicker = {
      ...timePicker,
      name,
      render(children, ctx) {
        return ctx.$render.vNode['timeRangePicker'](ctx.prop, children);
      }
    };

    var parsers = [checkbox, datePicker, rangePicker, hidden, input, timePicker, timeRangePicker, tree, radio, select, row];

    const PRE = 'a';
    var alias = {
      tooltip: PRE + 'Tooltip',
      popover: PRE + 'Popover',
      button: PRE + 'Button',
      icon: PRE + 'Icon',
      slider: PRE + 'Slider',
      rate: PRE + 'Rate',
      upload: 'fcUpload',
      cascader: PRE + 'Cascader',
      timePicker: PRE + 'TimePicker',
      timeRangePicker: PRE + 'TimeRangePicker',
      datePicker: PRE + 'DatePicker',
      rangePicker: PRE + 'RangePicker',
      'switch': PRE + 'Switch',
      select: PRE + 'Select',
      checkbox: PRE + 'CheckboxGroup',
      radio: PRE + 'RadioGroup',
      inputNumber: PRE + 'InputNumber',
      treeSelect: PRE + 'TreeSelect',
      search: PRE + 'InputSearch',
      inputPassword: PRE + 'InputPassword',
      textarea: PRE + 'Textarea',
      formItem: PRE + 'FormItem',
      form: PRE + 'Form',
      frame: 'fcFrame',
      col: PRE + 'Col',
      row: PRE + 'Row',
      tree: PRE + 'Tree',
      autoComplete: PRE + 'AutoComplete',
      group: 'fcGroup',
      subForm: 'fcSubForm',
      object: 'fcSubForm'
    };

    const UNDEF = undefined;
    function getConfig() {
      return {
        form: {
          hideRequiredMark: false,
          layout: 'horizontal',
          labelAlign: 'right',
          labelCol: {
            span: 3
          },
          wrapperCol: {
            span: 21
          },
          validateOnRuleChange: true
        },
        row: {
          gutter: 0
        },
        submitBtn: {
          disabled: false,
          loading: false,
          type: 'primary',
          innerText: '提交',
          show: true,
          col: UNDEF,
          click: UNDEF
        },
        resetBtn: {
          disabled: false,
          loading: false,
          type: 'default',
          innerText: '重置',
          show: false,
          col: UNDEF,
          click: UNDEF
        }
      };
    }

    function isTooltip(info) {
      return info.type === 'tooltip';
    }
    function tidy(props, name) {
      if (!hasProperty(props, name)) return;
      if (is.String(props[name])) {
        props[name] = {
          [name]: props[name],
          show: true
        };
      }
    }
    function isFalse(val) {
      return val === false;
    }
    function tidyBool(opt, name) {
      if (hasProperty(opt, name) && !is.Object(opt[name])) {
        opt[name] = {
          show: !!opt[name]
        };
      }
    }
    function tidyRule(rule) {
      const _rule = {
        ...rule
      };
      delete _rule.children;
      return _rule;
    }
    var manager = {
      validate() {
        const form = this.form();
        if (form) {
          return form.validate();
        } else {
          return new Promise(v => v());
        }
      },
      validateField(field) {
        const form = this.form();
        if (form) {
          return form.validateFields(field);
        } else {
          return new Promise(v => v());
        }
      },
      clearValidateState(ctx) {
        const fItem = this.vm.refs[ctx.wrapRef];
        if (fItem) {
          fItem.clearValidate();
        }
      },
      tidyOptions(options) {
        ['submitBtn', 'resetBtn', 'row', 'info', 'wrap', 'col'].forEach(name => {
          tidyBool(options, name);
        });
        return options;
      },
      tidyRule({
        prop
      }) {
        tidy(prop, 'title');
        tidy(prop, 'info');
        return prop;
      },
      mergeProp(ctx) {
        ctx.prop = mergeProps([{
          info: this.options.info || {},
          wrap: this.options.wrap || {},
          col: this.options.col || {}
        }, ctx.prop], {
          info: {
            type: 'popover',
            placement: 'topLeft',
            icon: 'QuestionCircleOutlined'
          },
          title: {},
          col: {
            span: 24
          },
          wrap: {}
        }, {
          normal: ['title', 'info', 'col', 'wrap']
        });
      },
      getDefaultOptions() {
        return getConfig();
      },
      update() {
        const form = this.options.form;
        this.rule = {
          props: {
            ...form
          },
          on: {
            submit: e => {
              e.preventDefault();
            }
          },
          class: [form.className, form.class, 'form-create'],
          style: form.style,
          type: 'form'
        };
      },
      beforeRender() {
        const {
          key,
          ref,
          $handle
        } = this;
        extend(this.rule, {
          key,
          ref
        });
        extend(this.rule.props, {
          model: $handle.formData
        });
      },
      render(children) {
        if (children.slotLen()) {
          children.setSlot(undefined, () => this.makeFormBtn());
        }
        return this.$r(this.rule, isFalse(this.options.row.show) ? children.getSlots() : [this.makeRow(children)]);
      },
      makeWrap(ctx, children) {
        const rule = ctx.prop;
        const uni = `${this.key}${ctx.key}`;
        const col = rule.col;
        const isTitle = this.isTitle(rule);
        const {
          layout,
          col: _col
        } = this.rule.props;
        const item = isFalse(rule.wrap.show) ? children : this.$r(mergeProps([rule.wrap, {
          props: {
            ...tidyRule(rule.wrap || {}),
            name: ctx.id,
            rules: rule.validate,
            ...(layout !== 'horizontal' ? {
              labelCol: {},
              wrapperCol: {}
            } : {})
          },
          class: rule.className,
          key: `${uni}fi`,
          ref: ctx.wrapRef,
          type: 'formItem'
        }]), {
          default: () => children,
          ...(isTitle ? {
            label: () => this.makeInfo(rule, uni)
          } : {})
        });
        return layout === 'inline' || isFalse(_col) || isFalse(col.show) ? item : this.makeCol(rule, uni, [item]);
      },
      isTitle(rule) {
        if (this.options.form.title === false) return false;
        const title = rule.title;
        return !(!title.title && !title.native || isFalse(title.show));
      },
      makeInfo(rule, uni) {
        const titleProp = {
          ...rule.title
        };
        const infoProp = {
          ...rule.info
        };
        if (this.options.form.title === false) return false;
        if (!titleProp.title && !titleProp.native || isFalse(titleProp.show)) return;
        const isTip = isTooltip(infoProp);
        const children = [titleProp.title];
        if (!isFalse(infoProp.show) && (infoProp.info || infoProp.native) && !isFalse(infoProp.icon)) {
          const prop = {
            type: infoProp.type || 'popover',
            props: tidyRule(infoProp),
            key: `${uni}pop`
          };
          delete prop.props.icon;
          delete prop.props.show;
          delete prop.props.info;
          delete prop.props.align;
          delete prop.props.native;
          const field = isTip ? 'title' : 'content';
          if (infoProp.info && !hasProperty(prop.props, field)) {
            prop.props[field] = infoProp.info;
          }
          children[infoProp.align !== 'left' ? 'unshift' : 'push'](this.$r(mergeProps([infoProp, prop]), {
            [titleProp.slot || 'default']: () => this.$r({
              type: infoProp.icon === true ? 'QuestionCircleOutlined' : infoProp.icon || '',
              props: {
                type: infoProp.icon === true ? 'QuestionCircleOutlined' : infoProp.icon
              },
              key: `${uni}i`
            })
          }));
        }
        const _prop = mergeProps([titleProp, {
          props: tidyRule(titleProp),
          key: `${uni}tit`,
          type: titleProp.type || 'span'
        }]);
        delete _prop.props.show;
        delete _prop.props.title;
        delete _prop.props.native;
        return this.$r(_prop, children);
      },
      makeCol(rule, uni, children) {
        const col = rule.col;
        return this.$r({
          class: col.class,
          type: 'col',
          props: col || {
            span: 24
          },
          key: `${uni}col`
        }, children);
      },
      makeRow(children) {
        const row = this.options.row || {};
        return this.$r({
          type: 'row',
          props: row,
          class: row.class,
          key: `${this.key}row`
        }, children);
      },
      makeFormBtn() {
        let vn = [];
        if (!isFalse(this.options.submitBtn.show)) {
          vn.push(this.makeSubmitBtn());
        }
        if (!isFalse(this.options.resetBtn.show)) {
          vn.push(this.makeResetBtn());
        }
        if (!vn.length) {
          return;
        }
        let {
          labelCol,
          wrapperCol,
          layout
        } = this.rule.props;
        if (layout !== 'horizontal') {
          labelCol = wrapperCol = {};
        }
        const item = this.$r({
          type: 'formItem',
          key: `${this.key}fb`,
          props: {
            labelCol,
            wrapperCol,
            label: ' ',
            colon: false
          }
        }, vn);
        return layout === 'inline' ? item : this.$r({
          type: 'col',
          props: {
            span: 24
          },
          key: `${this.key}fc`
        }, [item]);
      },
      makeResetBtn() {
        const resetBtn = {
          ...this.options.resetBtn
        };
        const innerText = resetBtn.innerText;
        delete resetBtn.innerText;
        delete resetBtn.click;
        delete resetBtn.col;
        delete resetBtn.show;
        return this.$r({
          type: 'button',
          props: resetBtn,
          style: {
            width: resetBtn.width,
            marginLeft: '10px'
          },
          on: {
            click: () => {
              const fApi = this.$handle.api;
              this.options.resetBtn.click ? this.options.resetBtn.click(fApi) : fApi.resetFields();
            }
          },
          key: `${this.key}b2`
        }, [innerText]);
      },
      makeSubmitBtn() {
        const submitBtn = {
          ...this.options.submitBtn
        };
        const innerText = submitBtn.innerText;
        delete submitBtn.innerText;
        delete submitBtn.click;
        delete submitBtn.col;
        delete submitBtn.show;
        return this.$r({
          type: 'button',
          props: submitBtn,
          style: {
            width: submitBtn.width
          },
          on: {
            click: () => {
              const fApi = this.$handle.api;
              this.options.submitBtn.click ? this.options.submitBtn.click(fApi) : fApi.submit();
            }
          },
          key: `${this.key}b1`
        }, [innerText]);
      }
    };

    const maker$1 = {};
    function useAlias(maker) {
      ['treeSelect', 'upload', 'frame', 'autoComplete', 'cascader', 'datePicker', 'frame', 'inputNumber', 'inputPassword', 'radio', 'rate', 'switch', 'rate', 'slider', 'timePicker'].reduce((maker, name) => {
        maker[name] = creatorFactory(name);
        return maker;
      }, maker);
      maker.auto = maker.autoComplete;
      maker.number = maker.inputNumber;
      maker.time = maker.timePicker;
      maker.password = maker.inputPassword;
    }
    function useFrame(maker) {
      const types = {
        frameInputs: ['input', 0],
        frameFiles: ['file', 0],
        frameImages: ['image', 0],
        frameInputOne: ['input', 1],
        frameFileOne: ['file', 1],
        frameImageOne: ['image', 1]
      };
      Object.keys(types).reduce((maker, key) => {
        maker[key] = creatorFactory('frame', m => m.props({
          type: types[key][0],
          maxLength: types[key][1]
        }));
        return maker;
      }, maker);
      maker.frameInput = maker.frameInputs;
      maker.frameFile = maker.frameFiles;
      maker.frameImage = maker.frameImages;
    }
    function useSlider(maker) {
      maker['sliderRange'] = creatorFactory('slider', {
        range: true
      });
    }
    function useSelect(m) {
      const name = 'select';
      m.selectMultiple = creatorFactory(name, {
        mode: 'multiple'
      });
      m.selectTags = creatorFactory(name, {
        mode: 'tags'
      });
      m.selectCombobox = creatorFactory(name, {
        mode: 'combobox'
      });
    }
    function useUpload(maker) {
      const types = {
        image: ['image', 0],
        file: ['file', 0],
        uploadFileOne: ['file', 1],
        uploadImageOne: ['image', 1]
      };
      Object.keys(types).reduce((maker, key) => {
        maker[key] = creatorFactory('upload', m => m.props({
          uploadType: types[key][0],
          maxLength: types[key][1]
        }));
        return maker;
      }, maker);
      maker.uploadImage = maker.image;
      maker.uploadFile = maker.file;
    }
    useAlias(maker$1);
    useSlider(maker$1);
    useFrame(maker$1);
    useUpload(maker$1);
    useSelect(maker$1);

    var css_248z = ".form-create .form-create .ant-form-item{margin-bottom:22px}.form-create .form-create .ant-form-item .ant-form-item{margin-bottom:0}.form-create .form-create .ant-form-item.ant-form-item-with-help{margin-bottom:3px}.form-create .form-create .ant-form-item .ant-form-item.ant-form-item-with-help{margin-bottom:-22px}.form-create{width:100%}";
    styleInject(css_248z);

    function tidyBtnProp(btn, def) {
      if (is.Boolean(btn)) btn = {
        show: btn
      };else if (!is.Undef(btn) && !is.Object(btn)) btn = {
        show: def
      };
      return btn;
    }
    function extendApi(api, h) {
      extend(api, {
        validate(callback) {
          return new Promise((resolve, reject) => {
            const forms = api.children;
            const all = [h.$manager.validate()];
            forms.forEach(v => {
              all.push(v.validate());
            });
            Promise.all(all).then(() => {
              resolve(true);
              callback && callback(true);
            }).catch(e => {
              reject(e);
              callback && callback(e);
            });
          });
        },
        validateField(field, callback) {
          return new Promise((resolve, reject) => {
            const ctx = h.getFieldCtx(field);
            if (!ctx) return;
            const sub = h.subForm[ctx.id];
            const all = [h.$manager.validateField(ctx.id)];
            toArray(sub).forEach(v => {
              all.push(v.validate());
            });
            Promise.all(all).then(() => {
              resolve(null);
              callback && callback(null);
            }).catch(e => {
              reject(e);
              callback && callback(e);
            });
          });
        },
        clearValidateState(fields, clearSub = true) {
          api.helper.tidyFields(fields).forEach(field => {
            if (clearSub) this.clearSubValidateState(field);
            h.getCtxs(field).forEach(ctx => {
              h.$manager.clearValidateState(ctx);
            });
          });
        },
        clearSubValidateState(fields) {
          api.helper.tidyFields(fields).forEach(field => {
            h.getCtxs(field).forEach(ctx => {
              const subForm = h.subForm[ctx.id];
              if (!subForm) return;
              if (Array.isArray(subForm)) {
                subForm.forEach(form => {
                  form.clearValidateState();
                });
              } else if (subForm) {
                subForm.clearValidateState();
              }
            });
          });
        },
        btn: {
          loading: (loading = true) => {
            api.submitBtnProps({
              loading: !!loading
            });
          },
          disabled: (disabled = true) => {
            api.submitBtnProps({
              disabled: !!disabled
            });
          },
          show: (isShow = true) => {
            api.submitBtnProps({
              show: !!isShow
            });
          }
        },
        resetBtn: {
          loading: (loading = true) => {
            api.resetBtnProps({
              loading: !!loading
            });
          },
          disabled: (disabled = true) => {
            api.resetBtnProps({
              disabled: !!disabled
            });
          },
          show: (isShow = true) => {
            api.resetBtnProps({
              show: !!isShow
            });
          }
        },
        submitBtnProps: (props = {}) => {
          let btn = tidyBtnProp(h.options.submitBtn, true);
          extend(btn, props);
          h.options.submitBtn = btn;
          api.refreshOptions();
        },
        resetBtnProps: (props = {}) => {
          let btn = tidyBtnProp(h.options.resetBtn, false);
          extend(btn, props);
          h.options.resetBtn = btn;
          api.refreshOptions();
        },
        submit(successFn, failFn) {
          return new Promise((resolve, reject) => {
            api.validate().then(() => {
              let formData = api.formData();
              is.Function(successFn) && invoke(() => successFn(formData, api));
              is.Function(h.options.onSubmit) && invoke(() => h.options.onSubmit(formData, api));
              h.vm.emit('submit', formData, api);
              resolve(formData);
            }).catch((...args) => {
              is.Function(failFn) && invoke(() => failFn(api, ...args));
              reject(...args);
            });
          });
        }
      });
      return api;
    }

    var modelFields = {
      autoComplete: 'value',
      cascader: 'value',
      inputNumber: 'value',
      inputPassword: 'value',
      rate: 'value',
      slider: 'value',
      treeSelect: 'value',
      switch: 'checked'
    };

    const required = {
      name: 'required',
      load(inject, rule, api) {
        const val = parseVal(inject.getValue());
        if (val.required === false) {
          inject.clearProp();
        } else {
          const validate = {
            required: true,
            validator(_, v) {
              return new Promise((resolve, reject) => {
                is.empty(v) ? reject(validate.message) : resolve();
              });
            },
            ...val
          };
          if (!validate.message) {
            let title = rule.title || '';
            validate.message = ((typeof title === 'object' ? title.title : title) || '') + '不能为空';
          }
          inject.getProp().validate = [validate];
        }
        api.sync(rule);
      },
      watch(...args) {
        required.load(...args);
      }
    };
    function parseVal(val) {
      if (is.Boolean(val)) {
        return {
          required: val
        };
      } else if (is.String(val)) {
        return {
          message: val
        };
      } else if (is.Function(val)) {
        return {
          validator: val
        };
      } else if (!is.Object(val)) {
        return {};
      } else {
        return val;
      }
    }

    function install(FormCreate) {
      FormCreate.componentAlias(alias);
      Object.keys(modelFields).forEach(k => {
        FormCreate.setModelField(k, modelFields[k]);
      });
      components.forEach(component => {
        FormCreate.component(component.name, component);
      });
      FormCreate.register(required);
      parsers.forEach(parser => {
        FormCreate.parser(parser);
      });
      Object.keys(maker$1).forEach(name => {
        FormCreate.maker[name] = maker$1[name];
      });
      if (typeof window !== 'undefined' && window.antd) {
        FormCreate.useApp((_, app) => {
          app.use(window.antd);
        });
      }
    }
    function antdvFormCreate() {
      return FormCreateFactory({
        ui: 'ant-design-vue',
        version: '4.0.0',
        manager,
        install,
        extendApi,
        attrs: {
          normal: ['col', 'wrap'],
          array: ['className'],
          key: ['title', 'info']
        }
      });
    }

    const FormCreate = antdvFormCreate();
    if (typeof window !== 'undefined') {
      window.formCreate = FormCreate;
    }
    const maker = FormCreate.maker;

    exports["default"] = FormCreate;
    exports.maker = maker;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
